//////////////////////////////////////////////////////////////////////
//  : Const.h
//  : MVC++6.0
//
//    PROP:
//  0x3200-0x33ff ,
//  0x3400-0x35ff ,
//  0x3600-0x36ff , 
//  0x3700-0x38ff ,
//  0x3900-0x3aff ,
//  0x5000-0x51ff 
//  (c)  "" 2001-2011.
//////////////////////////////////////////////////////////////////////
#pragma once
#ifndef _CONST_H_
#define _CONST_H_
// Common
#define MAX_DEVICE 85
// 
enum errors
{
	ERROR_NOERROR= 0,
// Global Errors
	ERROR_ANY_ERROR= 1,										// Error without description (yet)
	ERROR_MEMORY_ALLOC= 2,
	ERROR_TOO_MANY_SELECTORS= 3,
	ERROR_METHOD_NOT_INHERITED= 4,							// Function not implemented yet
	ERROR_REENTERING_IRQ= 5,
// Devices/Modules Errors
	ERROR_DEVICE_NOT_FOUND= 9,
	ERROR_DEVICE_UNKNOWN= 10,								//     
	ERROR_INCORRECT_DEVICE_ID= 11,
	ERROR_DEVICE_NOT_PRESENT= 12,
	ERROR_MODULE_NOT_PRESENT= 13,
	ERROR_BIOS_CODE_NOT_FOUND= 14,
	ERROR_FLEX_CODE_NOT_FOUND= 15,
	ERROR_BAD_FLEX_CODE= 16,
	ERROR_TOO_MANY_DEVICES= 17,
	ERROR_BIOS_NOT_LOADED= 18,
	ERROR_FLEX_NOT_LOADED= 19,
	ERROR_DEVICE_NOT_INITIALISED= 20,
	ERROR_DEVICE_NOT_PROGRAMMED= 21,
	ERROR_DEVICE_NOT_ACTIVATED= 22,
	ERROR_DEVICE_NOT_INTERFACE= 23,
	ERROR_DEVICE_NOT_TRANSFER= 24,
	ERROR_DEVICE_NOT_RESPOND= 25,
	ERROR_DEVICE_ALREADY_ACTIVATED= 26,
	ERROR_DEVICE_ALREADY_PROGRAMMED= 27,
	ERROR_DEVICE_ALREADY_INITIALISED= 28,
	ERROR_BIOS_ALREADY_LOADED= 29,
	ERROR_WINDRIVER_HANDLE= 30,
	ERROR_WINDRIVER_INCORRECT_VERSION= 31,
	ERROR_CREATE_EVENT= 32,
	ERROR_OVERLAPPED= 33,
	ERROR_KPOPEN= 34,
	ERROR_DMALOCK= 35,
	ERROR_IFACE= 36,
	ERROR_INI_FILE= 37,
	ERROR_CC_NULL= 38,
	ERROR_MODULE_NULL= 39,
	ERROR_HANDLE_NULL= 40,
	ERROR_FLAG_BIOS_LOAD= 41,
	ERROR_MODULE_BIOS_CODE_NULL= 42,
	ERROR_DEVICE_NULL= 43,
	ERROR_ENABLE_IRQ= 44,
	ERROR_MAX_SIZE= 45,
	ERROR_SINGLE_RUNNING= 46,								//    
	ERROR_WAIT_RDY= 47,
	ERROR_TIMEOUT_MANAGE= 48,
	ERROR_MEASURE_FREQ_MODULE= 49,
// Scan Errors
	ERROR_INCORRECT_SCAN_ID= 50,
	ERROR_UNKNOWN_SCAN_TYPE= 51,
	ERROR_CANT_CREATE_SCAN= 52,
	ERROR_SCAN_NULL= 53,
// Channel Errors
	ERROR_CHAN_NOT_EXIST= 58,
	ERROR_INCORRECT_CHAN_ID= 59,
	ERROR_READBUFFER_OVERFLOW= 60,
	ERROR_BAD_BUFFER_PTR= 61,
	ERROR_TRIGGER_NOT_DEFINED= 62,
	ERROR_CHAN_NULL= 63,
// TEST TMI
	ERROR_TEST_DM= 64,
	ERROR_TEST_PM= 65,
	ERROR_TEST_DM_PCI= 66,
	ERROR_TEST_PM_PCI= 67,
	ERROR_TEST_IRQ= 68,
	ERROR_TEST_IO= 69,
	ERROR_CLSID_NULL= 70,
	ERROR_PTRANSFORMER_NULL= 71,
	ERROR_TEST_ERROR= 72,
	ERROR_TRANSFER= 73,
	ERROR_ILLEGAL_MODULE_TYPE= 74,
	ERROR_CANT_READ_MODULE_FLASH= 75,
	ERROR_CALLCOMMAND_TIMEOUT_USER= 76,
	ERROR_GETINTERNALMEM= 77,
	ERROR_GETINTERNALMEMHEAP= 78,
	ERROR_TRIGGER_FAULT= 79,
	ERROR_CMD_TIMEOUT= 80,
// Common errors
	ERROR_DB_EMPTY= 0x2001,
	ERROR_UNKOWN_FORMAT= 0x2002,
	ERROR_STORAGE_FULL= 0x2003,
	ERROR_INSUFFICIENT_SPACE= 0x2004,
	ERROR_WD_CARDREG= 0x2005,
	ERROR_LCR_READ_WRITE= 0x2006,
	ERROR_ITEM_NOT_PRESENT= 0x2007,
	ERROR_BIOS_START_UPLOAD= 0x2008,
	ERROR_BIOS_STOP_UPLOAD= 0x2009,
	ERROR_FLEX_START_UPLOAD= 0x2010,
	ERROR_FLEX_STOP_UPLOAD= 0x2011,
	ERROR_INVALID_ARGUMENT= 0x2100,
// Properties Errors
	ERROR_BAD_PROPERTY_ID= 0xFFF0,							//      
	ERROR_BAD_PROPERTY= 0xFFF1,								//    
	ERROR_R_ONLY_PROPERTY= 0xFFF2,							//    
	ERROR_W_ONLY_PROPERTY= 0xFFF3,							//    
//    PCI Plug-n-Play,   / PCI 	
	ERROR_BAD_PCI_RESOURCE= 0xFFF4,			
	ERROR_DEVICE_BUSY= 0xFFF5,
	ERROR_REGISTER_CARD= 0xFFF6,
	ERROR_EXTERNAL_DEVICE= 0xFFF7,
	ERROR_LAST_ERROR= 0xFFF8,
};
// ,  
enum VIBRO_CC
{
//  
	TEST_CC= 0,												// Testing on BIOS loaded
	FLEX_START_LOADING_CC= 1,
	FLEX_OUT_BUFFER_CC=	2,
	FLEX_STOP_LOADING_CC= 3,
	START_SCAN_MAIN_CC= 4,									//    
	STOP_SCAN_MAIN_CC= 5,									//    
	RESET_FIFO_CC= 6,										//  FIFO
	OUT_START_FLAG_CC= 8,									//    
	GET_PROPERTY_CC= 9,										//  
	SET_PROPERTY_CC= 10,									//  
	READ_BOOT_EEPROM= 11,
	WRITE_BOOT_EEPROM= 12,
	LOCK_BOOT_EEPROM= 13,
	ERASE_BOOT_EEPROM= 14,
	TEST_IRQ= 15,
//   
	TEST_IRQ_CC= 20,										//    ADSP  PC
	INIT_CC= 21,									//  .      BIOS
	SEND_2_CONT_REG_CC= 22,									//     
	NEW_CONFIG_WORD_CC= 23,									//       RG3 
	PAUSE_TIMER_CC= 24,			//     .     ..  
                                //        
	RESTORE_TIMER_CC= 25,									//     
	ENA_EXT_ADC_CC= 26,										//    
	RESET_ADC_CC= 27,										//   (   )
	RESET_DAC_CC= 27,										//  
//   
	RESET_CHAN_LIST_CC= 40,
	SET_CHAN_LIST_CC= 41,									//   
	RESET_TRIGGER_CC= 42,									//  
	CONFIG_TRIGGER_CC= 43,									//  
	DIS_FLOOR_SYNC_CC= 44,									//   
//   
	SET_GRID_CC= 50,										//   
	SET_FREQ_CC= 51,										//   
	SET_SYNTHEZ_CC= 52,										//   
	SET_RANGE_CC= 52,										//  
	SEND_BALANCE_CC= 53,									//     
	CONFIG_RAW_CC= 58,										//   
	CONFIG_DBL_CC= 59,										//    
	CONFIG_MIX_CC= 60,										//    
	CONFIG_TIMING_CC= 61,									//    
	CONFIG_IRQPC_CC= 62,									//      PC
	GET_FINAL_FLAG_CC= 63,									//     
	PROGRAM_MARK_CC= 64,									//     
	CONFIG_AOUT_CC= 66,										//      PC
	GET_AOUT_DESC_CC= 67,									//     
	DAC_REPLY_CC= 68,										//   
	STOP_DAC_REPLY_CC= 69,									//    
	D_IN_CC= 70,											//  
	D_OUT_CC= 71,											//  
	SEND_CALIBR_CC= 72,										//     
	INIT_DAC_TASK_CC= 73,									//      
	START_DAC_TASK_CC= 74,									//      
	STOP_DAC_TASK_CC= 75,									//      
	ASSIGN_TAR_CC= 80,
	SET_K_CALIBR_CC= 81,
	SET_CALIBR_DAC_CC= 82,
	CONFIG_STAT_CC= 83,
	SET_K_BALANCE_CC= 84,
	SET_ZR_OFFSET_CC= 85,
	GET_ZR_OFFSET_CC= 86,
	GET_K_CALIBR_CC= 87,
	GET_HARM_CC= 88,
	GET_MAX_MIN_CC= 89,
	APPLY_SEV_TASK= 99,
};
//   
#define CHEXT_AIN 0
#define CHEXT_AOUT 1
#define CHEXT_DIN 2
#define CHEXT_DOUT 3
#define CHEXT_UTSIN 4
#define CHEXT_UTSOUT 5
#define CHEXT_TECHIN 6
//   ( .. )
enum TType
{
	UNDEF_TYPE= 0,
// Channel
	UNDEF_CHTYPE= 1,
// -
	CRATE_CC_CHTYPE= 2,
	CRATE_EPP_CHTYPE= 3,
	CRATE_USB_CHTYPE= 4,
	CRATE_E1_CHTYPE= 5,
	CRATE_PCI_CHTYPE= 6,
//  
	MOD_MC114_CHTYPE= 7,
	MOD_MC201_CHTYPE= 8,
	MOD_MC212_CHTYPE= 9,
	MOD_MC227_CHTYPE= 0xa,
	MOD_MC451_CHTYPE= 0xb,
	MOD_LC10X_CHTYPE= 0xc,
	M2408_AIN_CHTYPE= 0x0d,									//   "  2408"
	M2408_AOUT_CHTYPE= 0x0e,								//   "  2408"
	M2408_DIN_CHTYPE= 0x0f,									//   "  2408"
	M2408_DOUT_CHTYPE= 0x10,								//   "  2408"
	MAC_AIN_CHTYPE= 0x11,
	M21156_AOUT_CHTYPE= 0x12,								//   "  21156"
	M2081_CHTYPE= 0x13,
	FILE_CHTYPE= 0x14,										//  
	MOD_MC40X_CHTYPE= 0x15,
	CC_DIGIN_CHTYPE= 0x16,
	MOD_MC402_CHTYPE= 0x17,									// MC-402
	MOD_MC402_DIN_CHTYPE= 0x18,								//    402
	MOD_LC302_CHTYPE= 0x19,									// LC302
	MOD_MC118_CHTYPE= 0x1a,									// MC118
	NI6143_AIN_CHTYPE= 0x1b,								//   " "
	M3408_AIN_CHTYPE= 0x1c,
	MX208_CHTYPE= M3408_AIN_CHTYPE,
	M2428_CHTYPE= 0x1d,
	BK269X_AIN_P1_L_CHTYPE= 0x1e,							// Microphone Input, Low Noise
	MOD_MC4003_CHTYPE= 0x1f,								// MC-4003
	MC118_TIN_CHTYPE= 0x20,
	MIC0185_AIN_CHTYPE= 0x21,
	MIC0185_TIN_CHTYPE= 0x22,
	SMBINCC_CHTYPE= 0x23,
	MOD_MB232_CHTYPE= 0x24,
	MOD_MB464_CHTYPE= 0x25,
	MOD_MB132_CHTYPE= 0x26,
	MIC140_AIN_CHTYPE= 0x27,
	MIC140_TIN_CHTYPE= 0x28,
	MOD_MR2081H_CHTYPE= 0x29,
	ME808_DIG_CHTYPE= 0x2A,
	ME808_UIN_CHTYPE= 0x2B,
	ME808_IIN_CHTYPE= 0x2C,
	ME808_RISOLATIN_CHTYPE= 0x2D,
	ME808_RLOADIN_CHTYPE= 0x2E,
	ME808_OVERLOADIN_CHTYPE= 0x2F,
	MEBIUS_CHTYPE= 0x30,
	MOD_MB2081_CHTYPE= 0x31,
	MB045_CHTYPE= 0x32,
	MB132_CHTYPE= 0x33,
	MB2081_CHTYPE= 0x34,
	MB232_CHTYPE= 0x35,
	MB464_CHTYPE= 0x36,
	MB2082_CHTYPE= 0x37,
	MR045_CHTYPE = 0x38,
	MOD_MR405_CHTYPE= 0x39,
	MEBIUS_MIC170_CHTYPE= 0x3A,
	MEBIUS_MIC183_CHTYPE = 0x3B,
	MR405_CHTYPE= 0x40,
	MBCRATE_CHTYPE= 0x41,
	MRCRATE_CHTYPE=0x42,
	SMBSPI_CHTYPE= 0x44,
	MO_CHTYPE= 0x70,
	RMS_CHTYPE= 0x71,
	PIKPIK_CHTYPE= 0x72,
	FREQ_CHTYPE= 0x73,
	HARM_CHTYPE= 0x74,
	AHARM_CHTYPE= HARM_CHTYPE,
	PHARM_CHTYPE= 0x75,
	IRIGB_CHTYPE= 0x76,
	MI170_AIN_CHTYPE= 0x77,
	MI170_TIN_CHTYPE= 0x78,
	ME033_CHTYPE= 0x79,
	ME033_SINGLE_CHTYPE= 0x7A,
	MEBIUS_MIC304_CHTYPE = 0x7B,
	SEVRS_CHTYPE= 0x7C,
	
//  
	SEV_CHTYPE= 0x80,
	M2408RCE_SEV_CHTYPE= 0x81,
	MOD_MC302_CHTYPE= 0x82,									// MC-302
	MOD_MC110_CHTYPE= 0x83,									// MC-110
	PID_CHTYPE=	0x84,										// PID
	MOD_ME320_CHTYPE= 0x85,									// ME-320
	CC_PWR_CHTYPE= 0x86,									// CC PWR        
	GNOM_CHTYPE= 0x87,
	MOD_ME330_CHTYPE= 0x88,									// ME-330
	MOD_ME230_CHTYPE= 0x89,									// ME-230
	MOD_ME340_CHTYPE= 0x8A,									// ME-340
	MOD_ME325_CHTYPE= 0x8B,                                 // ME-325	
	DSOUNDIN_CHTYPE= 0x90,
	ME908_1_AIN_CHTYPE= 0x92,
	N2690_AIN_CHTYPE= 0x93,
	MR_300_CHTYPE= 0x94,									//   MR-300
	MR_300_LCH_CHTYPE= 0x95,								//     
	MX132_CHTYPE= 0x96,										// MX-132
	OPC_CHTYPE= 0x97,										// OPC Output/Input Channel
	MX224_CHTYPE= 0x98,								        // MX-224
	MX240_CHTYPE= 0x99,									    // MX-240
	MX240AMP_CHTYPE= 0x9A,									// MX-240 Amplifier
	MX340_CHTYPE= 0x9B,                                     // MX-340
	MX340AMP_CHTYPE= 0x9C,                                  // MX-240 Amplifier
	MR202_CHTYPE= 0x9D,                                     // MR-202
	MX310_CHTYPE= 0x9E,                                     // MX-310
	MX310AMP_CHTYPE= 0x9F,                                  // MX-210 Amplifier
	MX020_CHTYPE= 0xa0,                                     // MX-020
	MX228_CHTYPE= 0xa1,                                     // MX-228
	GAUGE_CMN_AIN_CHTYPE= 0xc0,								// 
	GAUGE_TEDS_AIN_CHTYPE= 0xc1,

	ME812_DIG_CHTYPE= 0xC2,
	ME812_U_CHTYPE= 0xC3,
	ME812_I_CHTYPE= 0xC4,
	ME812_RISOL_CHTYPE= 0xC5,
	ME812_RLOAD_CHTYPE= 0xC6,
	ME812_OVER_CHTYPE= 0xC7,

// -----------      ..   255 -------------
	AIN_CHTYPE= 0x0100,										//        
	AOUT_CHTYPE= 0x0200,									//        
	DIN_CHTYPE= 0x0400,										//        
	DOUT_CHTYPE= 0x0800,									//        
	TECH_CHTYPE= 0x1000,									//       
	UTS_CHTYPE= 0x1100,										//     
//    .
//   . ""  .
//     ,      ALL_CHTYPE
	AVL_CHTYPE= 0x2000,										//    
	USED_CHTYPE= 0x4000,									//     (  Device)
	ALL_CHTYPE= (AVL_CHTYPE|USED_CHTYPE),					//    
// 
	CRATE_TYPE= 0x4001,
// -
	CRATE_ISA_TYPE= 0x4002,
	CRATE_EPP_TYPE= 0x4003,
	CRATE_USB_TYPE= 0x4004,
	CRATE_E1_TYPE= 0x4005,
	CRATE_E1_2_TYPE= 0x4006,
	CRATE_PCI_TYPE= 0x4007,
	CRATE_COMM_TYPE= 0x4008,
	COMM_TYPE= 0x4009,
	M2408_IFACE_TYPE= 0x400A,
	MC011_IFACE_TYPE= 0x400B,
	MC011PC_IFACE_TYPE= 0x400C,
	MC011ITE_IFACE_TYPE= 0x400D,
	E1_M20100_PLX9052_IFACE_TYPE= 0x400E,
	E1_2_M20100_PLX9052_IFACE_TYPE= 0x400F,
// 
	MOD_MC114_TYPE= 0x4010,
	MOD_MC201_TYPE= 0x4011,
	MOD_MC212_TYPE= 0x4012,
	MOD_MC227_TYPE= 0x4013,
	MOD_LC301_TYPE= 0x4014,
	MOD_MC451_TYPE= 0x4015,
	MOD_MC451V1_TYPE= 0x4016,
	MOD_MC451GV1_TYPE= 0x4017,
	MOD_LC101_TYPE= 0x4018,
	MOD_LC102H_TYPE= 0x4019,
	MOD_LC102HT_TYPE= 0x401A,
	MOD_LC102C_TYPE= 0x401B,
	MOD_MC227C_TYPE= 0x401C,
	MOD_MC227K_TYPE= 0x401D,
	MOD_MC227U_TYPE= 0x401E,
	MOD_MC227T_TYPE= 0x401F,
	MOD_MC227W_TYPE= 0x4020,
	MOD_MC227R_TYPE= 0x4021,
	MOD_MC201A_TYPE= 0x4022,
	MOD_LC302_TYPE= 0x4023,
	MOD_MC401_TYPE= 0x4024,
	MOD_MC402_TYPE= 0x4025,
	MOD_MC403_TYPE= 0x4026,
	MOD_MC801_TYPE= 0x4027,
	MOD_MAC_TYPE= 0x4028,
	MOD_MC114W31_TYPE= 0x4029,
	MOD_MC212W60_TYPE= 0x402A,
	MOD_LC227C_TYPE= 0x402B,								// LC-227
	MOD_LC227K_TYPE= 0x402C,
	MOD_LC227U_TYPE= 0x402D,
	MOD_LC227T_TYPE= 0x402E,
	MOD_LC227W_TYPE= 0x402F,
	MOD_LC227R_TYPE= 0x4030,
	MOD_MC227UP_TYPE= 0x4031,
	MOD_MC114W40_TYPE= 0x4032,
	MOD_DIGINCC_TYPE= 0x4033,
	MOD_MC227U_8_TYPE= 0x4034,
	MOD_MC4003_TYPE= 0x4035,
	MOD_SEV_TYPE= 0x4036,
	MOD_LC451F_TYPE= 0x4037,								// LC-451
	MOD_LC451S_TYPE= 0x4038,
	MOD_MC118_TYPE= 0x4039,									// MC-118
	MOD_MC118W50_TYPE= 0x403A,
	MOD_MC227S_TYPE= 0x403B,								// MC-227S	
	MOD_MC212V10_TYPE= 0x403C,								// MC-212 v10
	MOD_MC302_TYPE= 0x403D,									// MC-302V1
	MOD_MC110V1_TYPE= 0x403E,								// MC-110V1
	MOD_MC114V40C1_TYPE= 0x403F,							// MC-114V40 C1
	MOD_MC114V40C2_TYPE= 0x4040,							// MC-114V40 C2
	MOD_PID_TYPE= 0x4041,									// PID
	MOD_PWRCC_TYPE= 0x4042,									// CC PWR
	MOD_MC116V10_TYPE= 0x4043,
	MOD_MC405_TYPE= 0x4044,
	MOD_MC302V4_0_TYPE= 0x4045,											
	MOD_MC110V2_0_TYPE= 0x4046,								// MC-110V2
	MOD_MC406_TYPE= 0x4047,									// MC-406
	MOD_GNOM_TYPE= 0x4048,
	MOD_MC408_TYPE= 0x4049,	
	MOD_MC114V5_TYPE= 0x404A,
	MOD_MIC0183_TYPE= 0x404B,																		
	MOD_MIC0184_TYPE= 0x404C,																		
	MOD_MC114V6_TYPE= 0x404D,
	MOD_MIC0185_TYPE= 0x404E,	
	MOD_MIC0185V2_TYPE= 0x404F,	
	MOD_MR114_TYPE= 0x4050,	
	MOD_MC114V9_TYPE= 0x4051,
	MOD_SMBINCC_TYPE= 0x4052,
	MOD_MR405_TYPE= 0x4053,
	MOD_MR404_TYPE= 0x4054,
	MOD_MC212V20_TYPE= 0x4055,
	MOD_MB132_TYPE = 0x4056,
	MOD_MB232_TYPE=0x4057,
	MOD_MB464_TYPE=0x4058,
	MOD_MR406_TYPE= 0x4059,
	MOD_MIC140_96_TYPE= 0x405A,	
	MOD_MR2081H_TYPE= 0x405B,
	MOD_ME808_TYPE= 0x405C,
	MOD_MC114V9C2_TYPE= 0x405D,
	MOD_MR114V2_TYPE= 0x405E,
	MOD_MC114UP_TYPE= 0x405F,
	MOD_SCALAR_TYPE= 0x4060,	
	MOD_MR451_TYPE= 0x4061,
	MOD_MT132_TYPE= 0x4062,
	MOD_MT232_TYPE= 0x4063,
	MOD_IRIGB_TYPE= 0x4064,
	MOD_MR114V3_TYPE= 0x4065,
	MOD_MR114V3_1_TYPE= 0x4066,
	MOD_ME808V3_TYPE= 0x4067,
	MOD_MT464_TYPE= 0x4068,
	MOD_MR114V4_1_TYPE= 0x4069,
	MOD_MT230_TYPE= 0x406A,
	MOD_MT320_TYPE= 0x406B,
	MOD_MB2081_TYPE = 0x406C,
	MOD_MR114V4_TYPE= 0x406D,
	MOD_MT224_TYPE= 0x406E,
	MOD_MR2087_TYPE= 0x406F,
	MOD_MB132_MEB_TYPE=0x4070,
	MOD_MB2081_MEB_TYPE=0x4071,
	MOD_MB232_MEB_TYPE=0x4072,
	MOD_MB464_MEB_TYPE=0x4073,
	MOD_MB2082_MEB_TYPE=0x4074,
	MOD_MB2355_MEB_TYPE=0x4075,
	MOD_MR212_TYPE= 0x4076,
	MOD_MI170_TYPE= 0x4077,
	MOD_ME033_TYPE= 0x4078,	
	MOD_ME053_TYPE= 0x4079,	
	MOD_MR114V4C1_TYPE= 0x407A,	
	MOD_MR405_MEB_TYPE = 0x407B,
	MOD_MR114_MEB_TYPE = 0x407C,
	MOD_MR302_TYPE= 0x407D,
	MOD_MR451_MEB_TYPE = 0x407E,
	MOD_MB132_SPW_MEB_TYPE = 0x407F,
	MOD_MB232_SPW_MEB_TYPE = 0x4080,
	MOD_MB464_SPW_MEB_TYPE = 0x4081,
	MOD_ME812_TYPE= 0x4082,
	MOD_MT320V2_TYPE= 0x4083,
	MOD_MT212_TYPE= 0x4084,
	MOD_ME812V2_TYPE= 0x4085,
	MOD_MR401_TYPE= 0x4086,
	MOD_MT240_TYPE= 0x4087,
	MOD_MT310_TYPE= 0x4088,
	MOD_MT183_TYPE= 0x4089,
	MOD_MT464v5_TYPE = 0x408A,
	MOD_MT132V6_TYPE = 0x408B,
	MOD_MT232V7_TYPE= 0x408C,
	MOD_MR2355_TYPE= 0x408D,
	MOD_SMBSPI_TYPE= 0x408E,
	MOD_MR402_TYPE= 0x408F,
	MOD_MR406_MEB_TYPE= 0x4090,
	MOD_MR114V2_MEB_TYPE = 0x4091,
	MOD_MR401_MEB_TYPE = 0x4092,
	MOD_MR114V5_TYPE= 0x4093,
	MOD_MB142_MEB_TYPE=0x4094,
	MOD_MR202_TYPE= 0x4095,
	MOD_MB152_MEB_TYPE=0x4096,
	MOD_MB405_MEB_TYPE=0x4097,
	MOD_MR227_TYPE= 0x4098,
	MOD_MR212V4_TYPE= 0x4099,
	MOD_MR114V5_1_TYPE= 0x409A,
	MOD_MS304_MEB_TYPE=0x409B,
	MOD_MT224V4_TYPE=0x409C,
	MOD_MT181_TYPE=0x409D,
	MOD_MC227R1_TYPE= 0x409E,
	MOD_MC227R2_TYPE= 0x409F,
	MOD_MC227R3_TYPE= 0x40A0,
	MOD_MC227R4_TYPE= 0x40A1,
	MOD_MC227R5_TYPE= 0x40A2,
	MOD_MC227K1_TYPE= 0x40A3,
	MOD_MC227K2_TYPE= 0x40A4,
	MOD_MC227K3_TYPE= 0x40A5,
	MOD_MC227K11_TYPE= 0x40A6,
	MOD_MC227K21_TYPE= 0x40A7,
	MOD_MC227K31_TYPE= 0x40A8,
	MOD_MC227U1_TYPE= 0x40A9,
	MOD_MC227U2_TYPE= 0x40AA,
	MOD_MC227U3_TYPE= 0x40AB,
	MOD_MC227S1_TYPE= 0x40AC,
	MOD_MC227C1_TYPE= 0x40AD,
	MOD_MC227C2_TYPE= 0x40AE,
	MOD_MS142_MEB_TYPE=0x40AF,
	MOD_MR820_MEB_TYPE = 0x40B0,
	MOD_MT212V3_TYPE= 0x40B1,
	MOD_MB629_MEB_TYPE=0x40B2,
	MOD_MT227R_TYPE= 0x40B3,
	MOD_MS685_MEB_TYPE=0x40B4,
	MOD_MIC1170_MEB_TYPE=0x40B5,
	MOD_MT227UP_TYPE= 0x40B6,
	MOD_MIC140_48_TYPE= 0x40B7,	
	MOD_MR2355_MEB_TYPE = 0x40B8,
	MOD_MS202_MEB_TYPE = 0x40B9,
	MOD_MS405_MEB_TYPE = 0x40BA,
	MOD_MS451_MEB_TYPE = 0x40BB,
	MOD_MB628_MEB_TYPE = 0x40BC,
	MOD_MB2087v2_MEB_TYPE = 0x40BD,
	MOD_MR114V4_MEB_TYPE = 0x40BE,
	MOD_MR402_MEB_TYPE = 0x40BF,
	MOD_MR114V5_MEB_TYPE = 0x40C0,
	MOD_MS340_MEB_TYPE = 0x40C0,
	MOD_MS152_MEB_TYPE = 0x40C1,
	MOD_MR227R2_TYPE= 0x40C2,
	MOD_MT1500_TYPE = 0x40C3,
	MOD_SEVRS_TYPE= 0x40C4,
	MOD_MIC140_48V2_TYPE= 0x40C5,	
	MOD_ME415_TYPE= 0x40C6,	
	MOD_MT212V4_TYPE= 0x40C7,
	MOD_MR404_MEB_TYPE= 0x40C8,
	MOD_ME808_MEB_TYPE= 0x40C9,
	MOD_ME812V2_1_TYPE= 0x40CA,
	MOD_MR227R3_TYPE= 0x40CB,
	MOD_MR227R4_TYPE= 0x40CD,
	MOD_MR227R1_TYPE= 0x40CE,
	MOD_MR227R5_TYPE= 0x40CF,
	MOD_MR227R6_TYPE= 0x40D0,
	MOD_MR227U1_TYPE= 0x40D1,
	MOD_MR227U2_TYPE= 0x40D2,
	MOD_MR227U3_TYPE= 0x40D3,
	MOD_MR227UP_TYPE= 0x40D4,
	MOD_MR227C1_TYPE= 0x40D5,
	MOD_MR227C2_TYPE= 0x40D6,
	MOD_MR227S1_TYPE= 0x40D7,
	MOD_MR227K1_TYPE= 0x40D8,
	MOD_MT232V8_TYPE= 0x40D9,
	MOD_ME105_MEB_TYPE= 0x40DA,
	MOD_ME819_MEB_TYPE= 0x40DB,
	MOD_ME825_MEB_TYPE= 0x40DC,
	MOD_MR114V4C1_MEB_TYPE= 0x40DD,
	MOD_ME415_MEB_TYPE= 0x40DE,
	MOD_MB234_MEB_TYPE=0x40DF,
	MOD_MB236_MEB_TYPE=0x40C0,
	MOD_MB632_MEB_TYPE=0x40C1,
// 
	SCAN_201_TYPE= 0x4100,
	SCAN_212_TYPE= 0x4101,
	SCAN_451_TYPE= 0x4102,
	SCAN_114_TYPE= 0x4103,
	SCAN_227_TYPE= 0x4104,
	SCAN_301_TYPE= 0x4105,
	SCAN_40X_TYPE= 0x4106,
	SCAN_CLOCK_TYPE= 0x4107,
	SCAN_MAC_TYPE= 0x4108,
	SCAN_DIGINCC_TYPE= 0x4109,
	SCAN_SEV_TYPE= 0x410A,
	SCAN_118_TYPE= 0x410B,
	SCAN_DIGITIN402_TYPE= 0x410C,
	SCAN_GNOM_TYPE= 0x410D,
	SCAN_SMBINCC_TYPE= 0x410E,
	SCAN_PID_TYPE= 0x410F,
	SCAN_MB132_TYPE= 0x4110,
	SCAN_MB232_TYPE= 0x4111,
	SCAN_MB464_TYPE= 0x4112,
	SCAN_MIC140_TYPE= 0x4113,
	SCAN_MR2081H_TYPE= 0x4114,
	SCAN_ME808_TYPE= 0x4115,
	SCAN_SCALAR_TYPE= 0x4116,
	SCAN_DOUT_TYPE= 0x4117,
	SCAN_IRIGB_TYPE= 0x4118,
	SCAN_MEBIUS_TYPE= 0x4119,
	SCAN_MB045_TYPE= 0x411A,
	SCAN_MI170_TYPE= 0x411B,
	SCAN_ME033_TYPE= 0x411C,
	SCAN_MR045_TYPE= 0x411D,
	SCAN_MR405_TYPE= 0x411E,
	SCAN_MR114_TYPE= 0x411F,	
	SCAN_MR451_TYPE= 0x413B,
	SCAN_MR212_TYPE= 0x413C,
	SCAN_ME812RLOAD_TYPE= 0x413D,
	SCAN_ME812OVER_TYPE= 0x413E,
	SCAN_SMBSPI_TYPE= 0x413F,
	SCAN_MR202_TYPE= 0x4140,
	SCAN_SEVRS_TYPE= 0x4141,
// . 
	MC012COM_IFACE_TYPE= 0x4120,							//  MC-012
	MC012USB_IFACE_TYPE= 0x4121,																	
	USB_FTDI_TYPE= 0x4122,
	USB_FTDI_81_TYPE= 0x4123,
	MC021USB_IFACE_TYPE= 0x4124,
	MIC0183_TYPE= 0x4125,
	MIC0184_TYPE= 0x4126,
	ETHERNET_81_TYPE= 0x4127,
	MC031ETHERNET_IFACE_TYPE= 0x4128,
	MIC0185_TYPE= 0x4129,
	MR031ETHERNET_IFACE_TYPE= 0x412A,
	MC032ETHERNET_IFACE_TYPE= 0x412B,
	MR032ETHERNET_IFACE_TYPE= 0x412C,
	MIC140_96_TYPE= 0x412D,
	MIC140_96ETHERNET_IFACE_TYPE= 0x412E,
	
	MEBIUS_DEVICE_ETHERNET_IFACE_TYPE= 0x412F,
	ETHERNET_MEBIUS_TYPE= 0x4130,
	MR035ETHERNET_IFACE_TYPE= 0x4131,
	MB045ETHERNET_IFACE_TYPE= 0x4132,
	SCAN_MB2081_TYPE= 0x4133,
	MB045_TYPE= 0x4134,
	MB045_DEVICE_ETHERNET_IFACE_TYPE= 0x4135,	
	MIC170_TYPE= 0x4136,
	MIC1200_TYPE= 0x4137,
	ME033_ETHERNET_IFACE_TYPE= 0x4138,
	MR045_TYPE = 0x4139,
	MR045_DEVICE_ETHERNET_IFACE_TYPE = 0x413A,
	MR032V4ETHERNET_IFACE_TYPE= 0x413B,
	MIC140_48_TYPE= 0x413C,
	MIC140_48ETHERNET_IFACE_TYPE= 0x413D,
	MIC140_48V2_TYPE= 0x413E,
	MIC140_48V2ETHERNET_IFACE_TYPE= 0x413F,
	
	MEBIUS_BASED_DEVICE_TYPE=0x4400,
	MEBIUS_BASED_ETHERNET_IFACE_TYPE=0x4401,

	MB045_DEVICE_TYPE=0x4402,
	MB045_ETHERNET_IFACE_TYPE=0x4403,
	MB023_DEVICE_TYPE=0x4404,
	MIC170_DEVICE_TYPE=0x4405,
	MR045_DEVICE_TYPE = 0x4406,
	MR045_ETHERNET_IFACE_TYPE = 0x4407,
	MIC1100_DEVICE_TYPE=0x4408,
	MBCRATE_DEVICE_TYPE=0x4409,
	MRCRATE_DEVICE_TYPE=0x440A,
	MIC170V3_DEVICE_TYPE= 0x440B,
	MIC140_DEVICE_TYPE=0x440C,
	MIC200M_TYPE = 0x440D,
	MIC183_DEVICE_TYPE = 0x440E,
	MRCRATEV2_DEVICE_TYPE=0x440F,
	MIC1150_DEVICE_TYPE=0x4410,
	MIC304_DEVICE_TYPE=0x4411,	
	MR2507_DEVICE_TYPE=0x4412,
	MIC170V4_DEVICE_TYPE= 0x4413,
	MIC224_DEVICE_TYPE=0x4414,
	MIC236_DEVICE_TYPE=0x4415,
	MIC170V5_DEVICE_TYPE= 0x4416,
//  ISA
	M1081_TYPE=	0x5000,
	M1181_TYPE=	0x5001,
	M1070_TYPE=	0x5002,
//  PCI/PXI
	M3408_TYPE=	0x800,
	MX208_TYPE=	M3408_TYPE,
	M2408_TYPE=	0x6080,
	M2081_TYPE=	0x6081,
	M2181_TYPE=	0x6082,
	M2091_TYPE=	0x6100,
	M2070_TYPE=	0x6083,
	M20100_TYPE= 0x6084,
	M21156_TYPE= 0x6085,
	MB_CPCI_TYPE= 0x6086,
	M2501_TYPE= 0x6087,
	M20100_PLX9052_TYPE= 0x6089,
	MAC300_TYPE= 0x608a,
	MR012_TYPE= 0x608b,
	MC012_TYPE= 0x608c,
	MR015_TYPE= 0x608d,
	MC021USB_TYPE= 0x608E,
	M2408_02_TYPE= 0x608F,
	DX_AUDIO_TYPE= 0x6090,
	M2428_TYPE= 0x6110,
	M2502_TYPE= 0x6111,
	MR2081_TYPE= 0x6114,
	MX132_TYPE= 0x6120,
	OPCDEV_TYPE= 0x6121,
	MX224_TYPE =0x6130,
	MX240_TYPE =0x6131,
	MX340_TYPE =0x6132,
	MX310_TYPE =0x6133,
	MX020_TYPE =0x6134,
	ME918_HUB_TYPE =0x6137,   //   ME918   RS-485
	MX228_TYPE =0x6138,
	MC_MDP_TYPE= 0x6180,
	M2081COMMUT_TYPE= 0x6182,
	WX753_TYPE= 0x6183,
	CYPRESS_TYPE= 0x3042,
	PLX9050_TYPE= 0x9050,
	ME_SPI_MDP_TYPE=0x7001, //  MDP (MERA SPI)
	ME_485_MDP_TYPE=0x7002, //  MDP (ME-918 - RS-485)
	ME_HUB_MDP_TYPE=0x7003, //  MDP (RS-485 - SPI - HUB)
//    RS/USB-
	MAC_TYPE,
//    (  0x7000 ... 0x7fff)
	MP07_TYPE= 0x7000,
	ME908_TYPE= 0x7001,
	MM202_TYPE= 0x7010,										//   MC201
	NI6143_TYPE= 0x70c0,									//  NI
//      
	BK2690_TYPE= 0x7200,									// Bruel&Kjaer Nexus Conditioning Amplifier Type 2690-2693
//     
	MOD_ME320F_TYPE= 0x7400,								// ME-320F
	MOD_ME320L_TYPE= 0x7401,								// ME-320L
	MOD_ME320LLU_TYPE= 0x7402,								// ME-320LLU
	MOD_ME320LLI_TYPE= 0x7403,								// ME-320LLI
	MOD_ME320V8F_TYPE= 0x7404,								// ME-320v8(F)
	MOD_ME320V8L_TYPE= 0x7405,								// ME-320v8(L)
	MOD_ME320V9F_TYPE= 0x7406,								// ME-320v9(F)
	MOD_ME320V9L_TYPE= 0x7407,								// ME-320v9(L)
	ME320_TYPE=	0x740f,										// ME-320
	MOD_ME330_TYPE=	0x7410,									// ME-330
	MOD_ME230_TYPE=	0x7411,									// ME-230
	MOD_ME340_TYPE=	0x7412,									// ME-340
	MOD_ME230V3_TYPE= 0x7413,								// ME-230v3
	MOD_ME320F2_TYPE= 0x7414,								// ME-320F
	MOD_ME230V5_TYPE= 0x7415,                               // ME-230v5
	MOD_ME230V6_TYPE= 0x7416,                               // ME-230v6
	MOD_ME230V4_TYPE= 0x7417,                               // ME-230v4
	MOD_ME230V7_1_TYPE= 0x7418,                             // ME-230v7_1
	MOD_ME325_TYPE= 0x7419,                                 // ME-325v1
	MOD_ME325V2_TYPE= 0x741A,                               // ME-325v2
	MOD_ME230V10_TYPE= 0x741B,                              // ME-230v10
	MOD_ME340V5_TYPE= 0x741C,                               // ME-340v5
//  (  0x8000 ... 0x8fff)
	GAUGE_COMMON_TYPE= 0x8000,
	GAUGE_UNI_TYPE= 0x8001,
	GAUGE_TEDS_TYPE= 0x8002,
//  RXI (  0x9000-0x9fff)
	CRATE_RXI1_TYPE= 0x9000,								//  : .+16			
	CRATE_RXI2_TYPE= 0x9001,								//  : 16
	CRATE_MIC017_2_TYPE= 0x9002,
	CRATE_MIC254_TYPE= 0x9003,
	MIC800_TYPE= 0x9004,	
	MIC850_TYPE= 0x9005,
	CRATE_PXI_TYPE= 0x9006,							
	MBP804_TYPE= 0x9007,	
	
	MR012COM_IFACE_TYPE= 0x9010,							// KK MR-012 COM
	MR012USB_IFACE_TYPE= 0x9011,							// KK MR-012 USB
	MR015USB_IFACE_TYPE= 0x9012,							// KK MR-015 USB
	MR015COM_IFACE_TYPE= 0x9013,	
//		
	TYPE_TEMP,												// device, with cleared FLASH (new device)
// HUBs
	TYPE_HUB= 0x1000,
	TYPE_MC_HUB= 0x1001,
	TYPE_ROOT= 0x2000,
	TYPE_ROOT_ISA=  TYPE_HUB|TYPE_ROOT,
	TYPE_ROOT_PCI,
	TYPE_ROOT_EPP,
	TYPE_ROOT_COM,
	TYPE_ROOT_ETHERNET,
	TYPE_ROOT_USB,
	LAST_TYPE= 0x7FFFFFFF
};
//        
#define IS_EXT_AMPLIF(_Type) ((_Type&0xf000) == 0x7000 && (_Type!=NI6143_TYPE))
//       
#define IS_GAUGE(_Type) ((_Type&0xf000) == 0x8000)
//      / /
#define IS_DAQ_DEVICE(_Type) (!IS_EXT_AMPLIF(_Type) && !IS_GAUGE(_Type))

#define TYPE_EXT_NONE 0
#define TYPE_EXT_AMPLIF 1
#define TYPE_ME918 2
#define TYPE_ME908_1 3
//  , 
#define STATE_PRESENT 0x00000001							// Present, but may by offline
#define STATE_ONLINE 0x00000002								// with active connection
#define STATE_INITIALIZED 0x00000004						// loaded with task-specific BIOS
#define STATE_PROGRAMMED 0x00000100 
#define STATE_RUN 0x00000200
#define STATE_BIOS_CHANGED 0x00010000						//   -  
#define STATE_FLEX_CHANGED 0x00020000						//  flex -  
#define STATE_CHAN_CHANGED 0x00040000						//   
#define STATE_FS_CHANGED 0x00080000							//    
#define STATE_BUF_CHANGED  0x00100000						//    -   
#define STATE_CONNECTING   0x00200000						//  
// 
enum TProperty 
{
	PROP_NAME= 0x1000,							// R/W   (. "M2408")
	PROP_INFO= 0x1001,									//    (, lpf-ON, hpf- OFF)
// ----------------------      ------------------------
	DEVICE_DESC_PRP= 0x1002,					//  
	REV_DEV= 0x1003,							//   
	PROP_REV= REV_DEV,					        //   
	SN_DEV= 0x1004,								//    ( . PROP_SN)
	PROP_TYPE= 0x1005,							//  .    
	PROP_TYPE_EXT= 0x1006,						//   (.   CHEXT_AIN)
	CHAN_CNT_DEV= 0x1007,						//       (    Index)
	PROP_CHAN_CNT= CHAN_CNT_DEV,
	PROP_HADC_SRC= 0x1008,						//     
	PROP_BIOS_PATH= 0x1009,						//    BIOS 
	PROP_CALIBR_DIR= 0x100A,					//   Calibr  
	PROP_BIOS_SIZE= 0x100B,						//  BIOS 
	PROP_FLEX_PATH= 0x100C,						//    FLEX 
	PROP_FLEX_SIZE= 0x100D,						//   FLEX 
	PROP_BIOS_DIR= 0x100E,						//  BIOS
	PROP_TRIGGER= 0x100F,						// R/W;   0-, 1-TTL IN, 2-Analog IN
	PROP_TRIG_SRC= 0x1010,						// R/W;  
	PROP_TRIG_LEVEL= 0x1011,					// R/W;   ( TTL - 0/1,  .  
	PROP_INPUT_MODE= 0x1012,					// R/W;     (//icp),   0
	PROP_INPUT_MODE_STR= 0x1013,                // R;      
	PROP_ROUTE= 0x1014,							// R/W;  . C  TDeviceRoute  TDevice
	PROP_ME_SPI_CTRL= 0x1015,					// R;    ME-SPI (Me908, Me908-1), TRUE/FALSE
	MODULE_CNT_DEV= 0x1016,						//  
	IRQ_DEV= 0x1017,							//  
	PROP_IRQ_COUNTER= 0x1018,					//    
	IRQ_CUR_INDEX_DEV= 0x1019,					//   
	PORT_DEV= 0x101A,
	PORT_CUR_INDEX_DEV= 0x101B,
	PROP_SLOT= 0x101C,
	PROP_ADDRESS= 0x101D,
	TIMER_PERIOD_DEV= 0x101E,
	IRQ_SCAN_DEV= 0x101F,						//    
	IRQ_SCAN_COUNT_DEV= 0x1020,					// - 
	PORT_SCAN_DEV= 0x1021,
	PORT_SCAN_COUNT_DEV= 0x1022,
	ARG_C_PRP= 0x1023,							//      ADSP
	ARG_PTR_PRP= 0x1024,						//     ADSP
	FS_DEV= 0x1025,
	SWITCH_PRP= 0x1026,
	PROP_MAX_MODULE_COUNT= 0x1027,
	PROP_MODULE= 0x1028,
	PROP_CHAN_SERNO= 0x1029,
	PROP_CHAN_TYPE_SIGNAL= 0x102A,
	PROP_CHAN_ISOUTPUT= 0x102B,
	PROP_OWNER_NAME= 0x102C,                     //  
	PROP_IFACE_DEVICE_NUM= 0x102D,
	PROP_DEV_FREQ_BACKPLANE= 0x102E,
	PROP_DEV_DEFAULT_FREQ_BACKPLANE= 0x102F,
	PROP_DEVICE_NUM= 0x1030,
	PROP_DEV_SYNC_CLK= 0x1031,
	PROP_DEV_IFACE= 0x1032,
	PROP_SEV_CHAN_ENABLE= 0x1033,
	PROP_DIGIN_CHAN_ENABLE= 0x1034,
	PROP_SYNC_START= 0x1035,                      //   
	PROP_SYNC_START_LEVEL= 0x1036,
	PROP_SYNC_START_ENABLED= 0x1037,
	PROP_IFACE_FREQ_CLK= 0x1038,
	PROP_IFACE_ISREADBUFINIRQ= 0x1039,
	PROP_DEVICE_ALIAS= 0x103A,
	PROP_DEV_VARS_RING0= 0x103B,
	PROP_DEV_VARS_RING0_SIZE= 0x103C,
	PROP_MODE_LPT= 0x103D,
	PROP_DELAY_LPT= 0x103E,
	PROP_DEV_NAME_SLOT= 0x103F,
	PROP_PWR_CHAN_ENABLE= 0x1040,
	PROP_START_ENABLE= 0x1041,
	PROP_STOP_ENABLE= 0x1042,
	PROP_CHAN_BUFF_LOST= 0x1043,
	PROP_CHAN_BUFF_LOST_COUNT= 0x1044,
	PROP_CHAN_BUFF_HEADER= 0x1045,
	PROP_GNOM_CHAN_ENABLE= 0x1046,
	PROP_DEVICE_CHANNEL= 0x1047,
	PROP_TEDS_SUPPORT= 0x1048,                   //     TEDS
	PROP_TEDS_OWNER= 0x1049,
	PROP_TEDS_INTF= 0x104A,                      //      
							      //  ITEDSChan,    MDP  (    )
// MODULE
	PROP_MOD212_FILTER= 0x104B,
	PROP_MOD212_MODE= 0x104C,
	PROP_MOD212_REFMODE= 0x104D,
	PROP_MOD212_CALIBRCHAN= 0x104E,
	PROP_MOD212_CALIBRTYPE= 0x104F,
	PROP_MOD212_DECIMAT= 0x1050,
	PROP_MOD212_CONNECTION= 0x1051,
	PROP_MOD212_OFFSET= 0x1052,
	PROP_MOD212_DAC= 0x1053,
	PROP_MOD212_TESTLINE= 0x1054,
// PID
	PROP_PID_X= 0x1055,
	PROP_PID_Y= 0x1056,
	PROP_PID_E= 0x1057,
// COMM Device
	PROP_COMM_BAUD= 0x1058,
	PROP_COMM_DATA= 0x1059,
	PROP_COMM_STOP= 0x105A,
	PROP_COMM_PARITY= 0x105B,
	PROP_COMM_INQUEUE= 0x105C,
	PROP_COMM_OUTQUEUE= 0x105D,
	PROP_ITEM_SIZE= 0x105E,
// Common
	PROP_DESC= 0x105F,							//   (,   )
	PROP_EXPL_PARAM_NAME= 0x1060,				// R/W,   , BSTR
	PROP_EXPL_PARAM= 0x1061,                    // R/W,   , BSTR
	PROP_RTSI_SEV= 0x1062,
	PROP_RTSI_CLK= 0x1063,
	PROP_RTSI_SYNC= 0x1064,
	PROP_BALANCE_NSAMPL= 0x1065,				// R/W -   
	PROP_FIRMWARE= 0x1066,
	PROP_STOR_BATT_STAT= 0x1067,
	PROP_IS_PRESENT_STOR_BATT= 0x1068,
	PROP_UTS_TYPE= 0x1069,
// PID
	PROP_PID_MODE_DSTY= 0x106A,
	PROP_PID_LEVEL_DSTY= 0x106B,
// -----------------------       ------------------------
	ID_CHAN= 0x3000,							// R; ChanID
	PROP_ID= ID_CHAN,
	INDEX_CHAN= 0x3001,                         // R;   /; 0-based;
	PROP_INDEX= INDEX_CHAN,
// *** ACQUISITION ***
	CONTINOUS_CHAN= 0x3002,						// R/W;    (default TRUE)
	ASYNC_CHAN= 0x3003,							// R/W;   (default TRUE)
	PROP_ASYNC= ASYNC_CHAN,
	DATA_TYPE_CHAN= 0x3004,						// R/W;  / 
	PROP_DATA_TYPE= DATA_TYPE_CHAN,
	PROP_DATA_TYPE_STR= 0x3005,					// R;  / , 
	PROP_CHAN_WORDLENGTH= 0x3006,				// R;  
	PROP_CHAN_ON= 0x3007,						// R/W; (long)   0=, 1=
	PROP_CHAN_TICK_COUNT= 0x3008,				// R/W; (long)      
// Events/timing
	ASYNCHRO_PRP= 0x3009,
//   
	PROP_FREQ_UNITS= 0x300A,				// R/W; (long)       
											//   ,   0.
	PROP_FREQ_UNITS_STR= 0x300B,			// R; ()       
	PROP_CHAN_FREQ= 0x300C,					// R/W;  , 
	PROP_CHAN_FREQ_COUNT= 0x300D,					// R; (long)   
	PROP_FREQ_INDEX= 0x300E,
	PROP_CHAN_FREQ_STR= 0x300F,						// R; ()       PROP_FREQ_UNITS
	PROP_FREQ_RANGE_MIN= 0x3010,         // R; (double)        PROP_FREQ_UNITS
	PROP_FREQ_RANGE_MIN_STR= 0x3011,     // R; ()        PROP_FREQ_UNITS
	PROP_FREQ_RANGE_MAX= 0x3012,		 // R; (double)        PROP_FREQ_UNITS
	PROP_FREQ_RANGE_MAX_STR= 0x3013,     // R; ()        PROP_FREQ_UNITS
	PROP_CHAN_T_OVER= 0x3014,            // R/W;   ,  .
	PROP_T_OVER= PROP_CHAN_T_OVER,
	PROP_CHAN_T_BLOCK= 0x3015,           // R/W;   (    ),  .
	PROP_T_EVENT= PROP_CHAN_T_BLOCK,
	PROP_ADSP_FIFO_SIZE= 0x3016,                // R/W;  FIFO   ADSP
	PROP_CHAN_HANDLER= 0x3017,                  // R/W;  
	PROP_CHAN_HANDLER_DATA= 0x3018,				// R/W;     
	PROP_HANDLER_PARAM= 0x3019,
	PROP_CHAN_HANDLER_ALTERN= 0x301A,					// R/W; 1 -    MR-300
	PROP_CHAN_INFO= 0x301B,								// RO;       
	PROP_MARK= 0x301C,									// R/W;   " "   
	PROP_IRQ_COUNT= 0x301D,								// R;  ,   0   ADSP (long)
	PROP_BLOCKS_TO_CLIENT= 0x301E,						// R;  ,   (long)
	PROP_BLOCKS_FROM_ADSP_LONG= 0x301F,					//   0   ADSP (long)
// Raw buffer access
	RAWBUF_BEGIN_CHAN= 0x3020,							//    "" 
	RAWBUFTX_BEGIN_CHAN= 0x3021,						//    "" 
	RAWBUF_SIZE_CHAN= 0x3022,							//   ""  ( ,  MIN_BUFFER_PRP)
	RAWBUF_TAIL_CHAN= 0x3023,							//      
	RAWBUF_HEAD_CHAN= 0x3024,							//    
	RAWBUF_PREC_CHAN= 0x3025,							//   "" 
	PROP_ADSP_LATENCY= 0x3026,							//          
	PROP_START_OFFSET= 0x3027,							// R;         
                                          //  -  .  .  ..  M2408  = (-33/Fs)
                                          // double, 
// *** ANALOG INPUT/OUTPUT PROPERTY ***
	PROP_CHAN_TRANSFORMER= 0x3028,
	PROP_CHAN_SWITCH= 0x3029,							// R/W;  / 
	PROP_CHAN_SWITCH_STR= 0x302A,						// R;    
	PROP_INPUT_VALID= 0x302B,        // R;  ,          
	                                 // S_OK =  , S_FALSE = , E_FAIL = 
	PROP_INPUT_INVALID_STR= 0x302C,  // R;     /
	PROP_SUBCHAN_ON= 0x302D,         // R/W; long;    //.
///////////////////       ////////////////////
	RANGE_COUNT_CHAN= 0x302E,        // R;  .  
	RANGE_CHAN= 0x302F,            // R/W;         (. )
	                               // : 
	                               // "10.0", "0.01", "0.00001"
	PROP_RANGE=RANGE_CHAN,
	PROP_RANGE_EXACT= 0x3030,      //         (. )
	INDEX_RANGE_CHAN= 0x3031,      // R/W;   , 
	PROP_RANGE_INDEX=INDEX_RANGE_CHAN,
	RANGE_CHAN_STR= 0x3032,                     // R;       , 
												//      a_lSubPropertyIndex ( Index)
												//      VT_EMPTY
												// : 
												// "10.0 ", "10.0 ", "10.0 "
	RANGE_CHAN_MIN= 0x3033,						// R;     
	RANGE_CHAN_MAX= 0x3034,						// R;     
	RANGE_CHAN_UNITS= 0x3035,					// R; (LPSTR)     ( )
	PROP_Y_UNITS= 0x3036,						// R/W; (long)    ,  ,   0
	PROP_RANGE_UNITS= PROP_Y_UNITS,			    // R/W; (long)     . ,   0
	PROP_Y_UNITS_STR= 0x3037,                   // R;    , 
	PROP_RANGE_UNITS_STR= PROP_Y_UNITS_STR,		// R;      , 
												//      a_lSubPropertyIndex ( Index)
												//      VT_EMPTY
												// : 
												// "", "", "", ""
	PROP_RANGE_UNITS_MULT= 0x3038,              // R;    (   ), double
												//      = 1.0
											//      a_lSubPropertyIndex ( Index)
											//     -   PROP_RANGE_UNITS_STR
											//      PROP_RANGE_UNITS_STR
											// : 
											// 0.001, 1.0, 1000.0, 1000000.0
											//       ( -  ),
											//   .  10.0  (  RANGE_CHAN)  
											// 1000.0 ( .  ""),  10000.0 
	PROP_LSB_WEIGHT= 0x3039,				// R;     (/) ()
	PROP_SENS_NOMINAL= 0x303A,				// R/W;    
	PROP_SENS= 0x303B,						// R/W;   //)  
											//     /  , double
											// :    (   )
											// k=y/x,  x -    , y -    
											//     .
											// :
											//   (    ) 
											// k_=RangeOut/RangeIn (     " ")
											//      ,   
											//      5%     .
											//     .
											//        :
											// RangeOut = k_ * RangeIn
											//  RangeOut     ""  ( )
											//       .
											//       ,  
											// RangeOut  RangeIn  .
											// :
											// k_   =  3.3;  0.77;  0.3; 0.07 /  (  )
											// RangeIn =  2.3;   7.1; 17.0; 52.0      ( -)
											// RangeOut= 7.59; 5.467;  5.1; 3.64        ( )

	PROP_SENS_NOM_STR= 0x303C,				// R/W;     ()

	PROP_ZR_OFFSET= 0x303D,					// R;   (    ), double
										    // PROP_SENS  PROP_ZR_OFFSET .      .
	PROP_AMPLIF_INDEX= 0x303E,              // R/W;   
	PROP_ATTEN_INDEX= 0x303F,               // R/W;  
//          ,   :
	PROP_BASE_AMPLIF= 0x3040,				// R/W;  ,     , double
	PROP_CHAN_AMPLIF= 0x3041,				// R/W;  ,     , double
	PROP_BALANCE_DAC= 0x3042,				// R/W;   
	PROP_BALANCE_VAL= 0x3043,               // R/W;      (DAQ-,   ..)  
												//    ,    (  
												//   )
	PROP_BALANCE_TYPE= 0x3044,					// R/W   0-  , 1-   
	PROP_BALANCE_ZOFFSET= 0x3045,				// R/W;       
	PROP_CALIBRATION= 0x3046,					// R/W;   
	PROP_CALIBR_FREQ= 0x3047,                   // R/W;   ,  (double)
    PROP_CALIBR_MAG= 0x3048,					// R/W;   , (double)

	PROP_IMITATOR= 0x3049,                      // R/W;     (200 Ohm), (BOOL)
	PROP_IMITATOR_VAL= 0x304A,                  // R/W;  , (double)
	

// **************      ************
	PROP_SENSOR_CIRCUIT= 0x304B,                // R/W;    (  - //)
	PROP_SENSOR_SPL= 0x304C,                    // R/W;   
	PROP_SENSOR_SPL_STR= 0x304D,                // R;      
	PROP_SENSOR_SPL_ON= 0x304E,                 // R/W;   
	PROP_SENSOR_SPL_UNITS= 0x304F,              // R/W;    (. /)
	PROP_SENSOR_SPL_I= 0x3050,                  // R/W;     (double, )
	PROP_SENSOR_SPL_U= 0x3051,                  // R/W;     (double, )
	PROP_SENSOR_SPL_RESTRICTION= 0x3052,		// R/W;    (0=, 1=)
	PROP_SENSOR_SPL_I_MIN= 0x3053,				// R/W;    ()
	PROP_SENSOR_SPL_I_MAX= 0x3054,				// R/W;    ()
	PROP_SENSOR_SPL_U_MIN= 0x3055,				// R/W;    ()
	PROP_SENSOR_SPL_U_MAX= 0x3056,				// R/W;    ()
	PROP_SENSOR_SPL_CLB_ON= 0x3057,				// R/W;     
	PROP_SENSOR_SPL_KU= 0x3058,					// R/W;      (/)
	PROP_SENSOR_SPL_ZU= 0x3059,					// R/W;       ()
	PROP_SENSOR_SPL_KI= 0x305A,					// R/W;      (/)
	PROP_SENSOR_SPL_ZI= 0x305B,					// R/W;       ()
	PROP_SENSOR_CALIBR= 0x305C,					// R/W;     
	PROP_SENSOR_SHUNT_R= 0x305D,				// R;  , 
	PROP_SENSOR_1_4_BRIDGE_COMPL_R= 0x305E,		// R;   1/4 , 
	PROP_SENSOR_1_4_BRIDGE_R= 0x305F,			// R;  1/4   (), 
// *** DIGITAL INPUT PROPERTY ***
	PROP_PORT= 0x3060,							// R/W;   (long)
	PROP_MASK= 0x3061,							// R/W;    
	PROP_SHIFT= 0x3062,							// R/W;   (  )
//////////////////////       ////////////////////
	PROP_OUT_RANGE= 0x3063,								// R/W;     , double
												// :    ,  
												//     !
	PROP_OUT_RANGE_EXACT= 0x3064,        //         (. )
	PROP_OUT_RANGE_STR= 0x3065,					// R;    , 
	PROP_OUT_RANGE_UNITS= 0x3066,				// R/W;     . ,   0
	PROP_OUT_RANGE_UNITS_STR= 0x3067,			//      , 
	PROP_OUT_RANGE_UNITS_MULT= 0x3068,			//    (   ), double
	PROP_OUT_LOCK= 0x3069,			            // R/W;    (    
									            //   )
	PROP_RANGE_MAX= 0x306A,						// R;     
	PROP_RANGE_MIN= 0x306B,						// R;     
	PROP_INDEX_OUT_RANGE= 0x306C,
	PROP_LPF_CNT= 0x306D,						// R;   
	PROP_LPF_CHAN= 0x306E,						// R/W;  
	PROP_LPF_STR= 0x306F,						// R; 
	PROP_HPF_CNT= 0x3070,						// R;   
	PROP_HPF_CHAN= 0x3071,						// R/W;  
	PROP_HPF_STR= 0x3072,						// R; 

	OVERLOAD_CHAN= 0x3073,						//   
	PROP_CHAN_SCAN_TYPE= 0x3074,
	PROP_WARNING_LEVEL= 0x3075,					// R/W;    
	PROP_CRASH_LEVEL= 0x3076,					// R/W;    
	PROP_X_UNITS= 0x3077,						// R/W;    
	PROP_X_UNITS_STR= 0x3078,					// R/W;    , 
	PROP_GAUGE_TYPE= 0x3079,					// R/W;  
// Chan M2408/MC201
	CODE_LO_CHAN= 0x307A,
	CODE_HI_CHAN= 0x307B,
	PROP_CHAN2408_SRC_ID= 0x307C,				// R/W; ChanID     ""
// Chan MX132
	PROP_RANGES= 0x307D,
	PROP_ADSP_CHAN_COUNT= 0x307E,
	PROP_1ST_CHAN_INPUT= 0x307F,		// R/W;      (0=, 1=)
//Chan212
	PROP_CHAN212_CONNECTIONTYPE= 0x3080,
	PROP_CHAN212_SENSE= 0x3081,
	PROP_CHAN212_RANGE= 0x3082,
	PROP_CHAN212_OFFSET= 0x3083,
	PROP_CHAN212_DAC= 0x3084,
// Scan
	PROP_SCAN_HANDLER= 0x3085,
	PROP_SCAN_HANDLER_DATA= 0x3086,
	PROP_SCAN_DIVIDER= 0x3087,
	PROP_SCAN_FIFO_SIZE= 0x3088,
	PROP_SCAN_TYPE= 0x3089,
	PROP_N_REFS= 0x308A,						// R;    
	PROP_U_REF_RANGE= 0x308B,					// R;    , Index -  
	PROP_U_REF= 0x308C,							// R/W;    , Index -  
	PROP_REF_RESOLUTION= 0x308D,				// R;          ( 0,
												//     ), Index -  
	PROP_ICP= 0x308E,							// R/W; 1=ICP , 0=ICP 
	PROP_DIN= 0x308F,
	PROP_WARN= 0x3090,
	PROP_CRASH= 0x3091,
	PROP_WARN_COLOR= 0x3092,
	PROP_CRASH_COLOR= 0x3093,	
	PROP_ALIAS= 0x3094,                          //   
//   National Instruments NI-6143
	PROP_NI6143_CHAN_NAME= 0x3095,				// R/W;       NI-DAQmx
	PROP_NI6143_AI_FREQ= 0x3096,				// R/W:      (  )
	STAT_AI_NTF_WAIT_TIMEOUTS= 0x3097,			// R:  -       
	STAT_AI_NTF_WAIT_FAILURES= 0x3098,		    // R:          
	STAT_AI_READ_ERRORS= 0x3099,				// R:     
	STAT_SAMPLES_RECEIVED= 0x309A,				// R:   
	STAT_SAMPLES_OVERRAN= 0x309B,				// R:      
	PROP_DBL_OFF= 0x309C,
	PROP_CHAN_INVERSION= 0x309D,	
	PROP_CHAN_CALIBR_STR= 0x309E,				// R;   c 
	PROP_CHAN_DAC_ENABLED= 0x309F,				// R/W;     
	PROP_CHAN_CALIBR_SHUNT= 0x30A0,				// R/W;   , long
	PROP_CHAN_CALIBR_LEVEL= 0x30A1,				// R/W;   +2.5 , long 
	PROP_CHAN_SUPPLY_TYPE= 0x30A2,				// R/W.   , long 0- U, 1-I
	PROP_CHAN_SUPPLY_U= 0x30A3,					// / U . , double
	PROP_CHAN_SUPPLY_I= 0x30A4,					// / I . , double
	PROP_CHAN_OUTPUT_U= 0x30A5,					// / U ., double
	PROP_CHAN_HPF= 0x30A6,						// R/W; , long
	PROP_CHAN_LPF= 0x30A7,						// R/W; , long
	PROP_CHAN_BALANCE_DAC_VOLT= 0x30A8,			// /  , double
	PROP_CHAN_BRIDGE= 0x30A9,					// /    ,    , long
	PROP_CHAN_CERTIF_AMPLIF= 0x30AA,			// R/W;   ,     
												// , double
	PROP_CHAN_CERTIF_OFFSET_U= 0x30AB,			// R/W;     , double
	PROP_CHAN_CERTIF_OFFSET_I= 0x30AC,			// R/W;     , double
	PROP_CHAN_CERTIF_MINMAX_U= 0x30AD,			// R/W;   ., .  , double
	PROP_CHAN_CERTIF_MINMAX_I= 0x30AE,			// R/W;   ., .  , double
	PROP_CHAN_FLAG_CERTIF_OFFSET_EXCEED= 0x30AF,// R/W;    , long 		
	PROP_CHAN_FLAG_CERTIF_MINMAX_EXCEED= 0x30B0,// R/W;    .. , long
	PROP_CHAN_NAME_NOMINAL_OFFSET_U= 0x30B1,	// R;     , str
	PROP_CHAN_NAME_NOMINAL_OFFSET_I= 0x30B2,	// R;     , str
	PROP_SMBINCC_CHAN_ENABLE= 0x30B3,			// R/W;     , long
	PROP_CHAN_VALUE_CMD= 0x30B4,				// R/W; ,  , double
	PROP_CHAN_MODE_CMD= 0x30B5,					// R/W; , ,   , long
	PROP_CHAN_CERTIF_LPF= 0x30B6,			    // R/W;   , double
	PROP_CHAN_CERTIF_HPF= 0x30B7,			    // R/W;   , double
	PROP_RMS_FREQ_BAND= 0x30B8,                 // R/W;    , 
	PROP_CHAN_FLAG_CAL_AMPL= 0x30B9,            // R/W;   , long 		
	PROP_CHAN_FLAG_CAL_BAL= 0x30BA,				// R/W;    , long 		
	PROP_CHAN_CAL_BAL_U= 0x30BB,                // R/W;        , double
	PROP_CHAN_CAL_BAL_I= 0x30BC,                // R/W;        , double
	PROP_CHAN_1_4_BRIDGE_R= 0x30BD,
	PROP_CHAN_SHUNT_R= 0x30BE,
	PROP_CHAN_SET_1_4_BRIDGE_R= 0x30BF,			// R/W;   1/4 , , long
	PROP_CHAN_SET_SHUNT_R= 0x30C0,				// R/W;   , , long
	PROP_CHAN_NOMINAL_AMPLIF= 0x30C1,			// R/W;   , double
	PROP_CHAN_NOMINAL_OFFSET_U= 0x30C2,			// R/W;     , double
	PROP_CHAN_NOMINAL_OFFSET_I= 0x30C3,			// R/W;     , double
	PROP_CHAN_NOMINAL_CAL_BAL_U= 0x30C4,        // R/W;        , double
	PROP_CHAN_NOMINAL_CAL_BAL_I= 0x30C5,        // R/W;        , double
	PROP_CHAN_EXCEED_CAL_BAL_U= 0x30C6,         // R/W;        , double
	PROP_CHAN_EXCEED_CAL_BAL_I= 0x30C7,         // R/W;        , double
	PROP_OUT_TYPE= 0x30C8,                      // R/W;  , long
	PROP_OUT_TYPE_STR= 0x30C9,                  // R/W;  , 
	PROP_CHAN_NOMINAL_RMS_FREQ_BAND= 0x30CA,    // R/W;    RMS  ,   flash
	PROP_CHAN_NOMINAL_LPF= 0x30CB,			    // R/W;   , double
	PROP_SENSOR_CIRCUIT_STR= 0x30CC,
	PROP_CHAN_AMPLIF_STR= 0x30CD,
	PROP_CHAN_CERTIF_SUPPLY_U= 0x30CE,			// /  U . , double
	PROP_CHAN_CERTIF_SUPPLY_I= 0x30CF,			// /  I . , double
	PROP_CHAN_SUPPLY= 0x30D0,			
	PROP_CHAN_CERTIF_SUPPLY= 0x30D1,			
	PROP_CHAN_SUPPLY_STR= 0x30D2,			
	PROP_CHAN_STEP_SUPPLY= 0x30D3,			
	PROP_CHAN_CERTIF_SUPPLY_STR= 0x30D4,
	PROP_CHAN_SUPPLY_TYPE_STR= 0x30D5,			
	PROP_SENSOR_BAL_ON= 0x30D6,
	PROP_CHAN_BALANCE_STR= 0x30D7,
	PROP_CHAN_STEP_BALANCE= 0x30D8,
	PROP_CHAN_BALOUT= 0x30D9,
	PROP_CHAN_BALOUT_STR= 0x30DA,
	PROP_CHAN_BAL_UNIT_STR= 0x30DB,
	PROP_CHAN_HPF_ON= 0x30DC,
	PROP_CHAN_HPF_STR= 0x30DD,
	PROP_CHAN_HPF_UNIT_STR= 0x30DE,
	PROP_CHAN_LPF_ON= 0x30DF,
	PROP_CHAN_LPF_STR= 0x30E0,
	PROP_CHAN_LPF_UNIT_STR= 0x30E1,
	PROP_CHAN_LPF_INDEX= 0x30E2, 
	PROP_CHAN_CALSHUNT_ON= 0x30E3,
	PROP_CHAN_CALSHUNT= 0x30E4,
	PROP_CHAN_CALSHUNT_STR= 0x30E5,
	PROP_CHAN_CALLEVEL_ON= 0x30E6,
	PROP_CHAN_CALLEVEL= 0x30E7,
	PROP_CHAN_CALLEVEL_STR= 0x30E8,
	PROP_CHAN_SIMULATORR_ON= 0x30E9,
	PROP_CHAN_SIMULATORR= 0x30EA,
	PROP_CHAN_SIMULATORR_STR= 0x30EB,
	PROP_CHAN_SIMULATORI_ON= 0x30EC,
	PROP_CHAN_SIMULATORI= 0x30ED,
	PROP_CHAN_SIMULATORI_STR= 0x30EE,
	PROP_CHAN_CALCHAN= 0x30F0,
	PROP_ATTEN_STR= 0x30F1,    
	PROP_CHAN_SUPPLY_U_STR= 0x30F2,					// / U . , str	
	PROP_CHAN_CERTIF_SUPPLY_U_STR= 0x30F3,			// / U . , str	
	PROP_CHAN_STEP_SUPPLY_U= 0x30F4,
	PROP_CHAN_SUPPLY_I_STR= 0x30F5,					// / I . , str	
	PROP_CHAN_CERTIF_SUPPLY_I_STR= 0x30F6,			// / I . , str	
	PROP_CHAN_STEP_SUPPLY_I= 0x30F7,
	PROP_CHAN_NOMINAL_HPF= 0x30F8,			        // R/W;   , double
	PROP_FLASH_SET_DEFAULT= 0x30F9,
	PROP_CAPACITY= 0x30FA,    	
	PROP_CALIBRATION_STR= 0x30FB,
	PROP_EXCIT_OUTPUT= 0x30FC,      // R/W; long,      ()
	PROP_EXCIT_OUTPUT_STR= 0x30FD,  // R/W;    
	PROP_EXCIT_OUTPUT_BLOCK= 0x30FE,// R/W; long,  PROP_EXCIT_OUTPUT   
// 
	PROP_MASK_CHAN= 0x3200,                         // R/W;  , long
	PROP_FLAG_TEST= 0x3201,                         // R/W;  , long
	PROP_READ_ADC= 0x3202,                          // R/W; 
	PROP_WRITE_CTRL= 0x3203,
	PROP_FLAG_ANALOG= 0x3204,
	PROP_CHAN_ANALOG= 0x3205,
	PROP_CHAN_TEST= 0x3206,
	PROP_CHAN_KU= 0x3207,
	PROP_CHAN_KV= 0x3208,
	PROP_FEED_WATCHDOG= 0x3209,
	PROP_CHAN_DIGIT= 0x320A,
	PROP_ENABLE_WATCHDOG= 0x320B,
	PROP_SENSOR_1_2_BRIDGE_COMPL_R= 0x320C,	  // R;   1/2 , 

	PROP_CHAN_ACOM=0x320D,                    //R/W    ACOM MT-183 
	PROP_CHAN_SHUNT_R_200_1=0x320E,           //MT183 1-  200  
	PROP_CHAN_SHUNT_R_100=0x320F,             //MT183  100  
	PROP_CHAN_SHUNT_R_200_2=0x3210,           //MT183 2-  200  

	PROP_CHAN_COMMUT=0x3211,                  // MC114(MR114)

// 
	PROP_CHAN_ATARE = 0x3601, ///     ( MIC140   )
// 
	PROP_SENSOR_CALIBR_STR = 0x3700, // R;      ()
//  0x3900-0x3aff
	PROP_CHAN_BUS_RATE = 0x3900, // R/W   MR-2355	
	PROP_CHAN_LINK_START_TYPE = 0x3901, // R/W   
	


// ------------------------------- TMI PROPERTY ----------------------------------------
	PROP_SN= 0x5000,
	PROP_TASK,
	PROP_IMASK,
	PROP_NWORD,
	PROP_CNT_FRAME,
	PROP_CNT_PART_FIFO,
	PROP_PARAM_INPUT,
	PROP_INT_HANDLER,
	PROP_DATA_HANDLER,
	PROP_CONTEXT,
	PROP_DIRECTION,
	PROP_FREQ_IN,
	PROP_FREQ_OUT,
// 
	PROP_DSTN_PATH,
	PROP_SOUR_PATH,
// Bios Param
	PROP_POS_FRONT_0,
	PROP_POS_FRONT_1,
	PROP_NEG_FRONT_0,
	PROP_NEG_FRONT_1,
	PROP_SYN_0,
	PROP_SYN_1,
	PROP_TIME_0,
	PROP_TIME_1,
	PROP_FRAME_0,
	PROP_FRAME_1,
	PROP_LENGTH_FRAME,
	PROP_LENGTH_SYN,
	PROP_LENGTH_DBL_SYN,
	PROP_LENGTH_TROUBLE,
	PROP_FREQ_TIMER,
	PROP_FREQ_SPORT,
	PROP_NUM_COUNT,
	PROP_MAX_COUNT,
	PROP_PRECISION_SPORT,
	PROP_SCALE_TIMER,
	PROP_TYPE_FLOW,
	PROP_TIMER_FLOW_0,
	PROP_TIMER_FLOW_1,
	PROP_CMD_REG_0,
	PROP_CMD_REG_1,
	PROP_OUT_DAC,
	PROP_RECOVERY,
	PROP_ONLINE,
	PROP_MERA_TIME,
	PROP_VERSION,
// M2181 M1181
	PROP_SW1,
	PROP_SW2,
	PROP_SW2_DUMMY,
	PROP_FLAG_REG,
	PROP_LEVEL,
	PROP_MIN_LEVEL,
	PROP_MAX_LEVEL,
	PROP_STEP_LEVEL,
// M2501
	PROP_FREQ_GTR1,
	PROP_FREQ_GTR2,
	PROP_SCIC2,
	PROP_SCIC5,
	PROP_RCF,
	PROP_PLL_COUNT,
	PROP_PLL_STEP,
	PROP_PLL_THR,
	PROP_N_POINT,
	PROP_FREQ_RCF,
	PROP_DEC_SCIC2,
	PROP_DEC_SCIC5,
	PROP_DEC_RCF,
	PROP_SAMP_FREQ,
	PROP_PLL_BORDER,
// M2502
	PROP_FREQ_SPORT1,
	PROP_FREQ_TIMER1,
	PROP_FREQ_GTR11,
	PROP_FREQ_GTR21,
	PROP_SCIC21,
	PROP_SCIC51,
	PROP_N_POINT1,
	PROP_DEC_SCIC21,
	PROP_DEC_SCIC51,
	PROP_PORT_MASK,
	PROP_LENGTH_FRAME1,
	PROP_PLL_COUNT1,
	PROP_PLL_STEP1,
	PROP_PLL_THR1,
	PROP_PLL_BORDER1,
// Filters & pins
	PROP_INPIN_ID,
	PROP_RUN,
	PROP_MDP_INITIALISED,
	PROP_DEBUG_STATE,
	PROP_BUFFER_FILL, // from mr300 mx224
	PROP_AMPLIFIER,
	PROP_SAVECALIBRTOFACTORY,
	PROP_IMPORTCALIBRTOFACTORY,
// *** DIGITAL INPUT/OUTPUT PROPERTY ***
	PROP_LAST= 0x7FFFFFFF
};
//
#define PROP_OK 0											/* Sucessfull return */
#define PROP_UNKNOWN 1										/* Unknown Property */
#define PROP_UNDEFINED 2									/* Known, but undefined yet (retry later) */
#define PROP_TIMEOUT_ERROR 3								/* Timeout error */
/* Events */
#define PROP_TRANSFER_CTX 8010								/* Context of transfer task */
#define PROP_MO 4100
#define PROP_MAX_MIN 4101
#define PROP_SKZ 4102
#define PROP_SKO 4103
#define PROP_F 4104											/* frequency estimation of channel  */
#define PROP_M_F 4110
#define PROP_A_F 4111
#define PROP_SKZ_F 4112
#define PROP_SKO_F 4113
#define PROP_P_F 4114
#define PROP_M_F_SUM 4120
#define PROP_A_F_SUM 4121
#define PROP_SKZ_F_SUM 4122
#define PROP_SKO_F_SUM 4123
#define PROP_HARM PROP_A_F
#define PROP_TAR_POLE 4130
#define PROP_ADC_CALIBR 4351
//  
enum
{
	NOTIFY_REMOVE_CHAN= 0,
	NOTIFY_GET_MAX_FIFOADSP_SIZE
};
// flags
enum
{
	FLAG_BIOS_LOAD= 0xA5A5,
	FLAG_COMMAND_FINISH= 0xA5A5,
	FLAG_TEST_LOAD= 0xA5A5
};
//  
typedef enum TTypeSignal
{
	TYPE_SIGNAL_CODE= 0,
	TYPE_SIGNAL_ELECTR= 1,
	TYPE_SIGNAL_TECH= 2
}DEVSIGNALTYPE;
//
#define VendorID_MERA 0x1945
#define VendorID_PLX 0x10b5
#define VendorID_NI 0x1093									// National Instruments
// RTSI
#define RTSI_SLAVE 0
#define RTSI_LINE_MASTER 1
// UTS 
#define UTS_TYPE_MERA 0
#define UTS_TYPE_IRIGB_LOCALTIME 1
#define UTS_TYPE_IRIGB_UTCTIME 2
#define UTS_TYPE_SEVRS_LOCALTIME 3
#define UTS_TYPE_SEVRS_UTCTIME 4
#define UTS_TYPE_IRIGBNOYEAR_LOCALTIME 101
#define UTS_TYPE_IRIGBNOYEAR_UTCTIME 102

enum { IDX_CHANDLG_MAIN = 0, IDX_CHANDLG_SECOND=1, IDX_CHANDLG_SM = 10, IDX_CHANDLG_SEC_SM=11};

#endif
//