#ifndef IDEVICE_H
#define IDEVICE_H

//#include "types.h"

// {B167658E-567C-4766-AA4D-00F74BF02BEB}
static const GUID IID_IDevice = 
{ 0xb167658e, 0x567c, 0x4766, { 0xaa, 0x4d, 0x0, 0xf7, 0x4b, 0xf0, 0x2b, 0xeb } };




enum{
	DEVPROP_NAME,               //  
	DEVPROP_DESC,               //  
	DEVPROP_IFACENAME,          //  
	DEVPROP_IFACEDESC,          //  
	DEVPROP_SERNUM,             //   
	DEVPROP_IFACESERNUM,        //   
	DEVPROP_MAX_MODULE_COUNT,   //      
	DEVPROP_MODULE_BY_SLOT,     //        
	DEVPROP_MODULE_BY_INDEX,    //       
	DEVPROP_INITIALIZED,        //   - ""
	DEVPROP_TYPE,               //  
	DEVPROP_SYNC_START_ENABLED, //   
	DEVPROP_ERROR_CODE,         //    
	DEVPROP_ALIAS,              //   
	DEVPROP_IFACE,              // 
	DEVPROP_SLOT_NAME,          //  
	DEVPROP_CONTEXT,
	DEVPROP_INT,
	DEVPROP_INT_DATA,
	DEVPROP_STATE,
	DEVPROP_DEBUG_STATE,
	DEVPROP_STATE_WORD          ///<    
	                            ///<     
	                            ///<  CCMC012COMWDInterface, CCMR032v4EthernetInterface 
								///<    
};


class IDevice: public IUnknown
{
public:
	virtual HRESULT STDMETHODCALLTYPE GetDeviceProperty(
			DWORD dwPropertyID, 
			VARIANT& Value, 
			LONG lSubPropertyIndex = NULL, 
			DWORD dwReserved = NULL
		) = 0;
	virtual HRESULT STDMETHODCALLTYPE SetDeviceProperty(
			DWORD dwPropertyID, 
			VARIANT& Value, 
			LONG lSubPropertyIndex = NULL, 
			DWORD a_dwReserved = NULL
		) = 0;
};

typedef IDevice* PIDevice;

// {81E13778-781B-4538-8CF1-A651DFDAC344}
static const GUID IID_ICrateDevice = 
{ 0x81e13778, 0x781b, 0x4538, { 0x8c, 0xf1, 0xa6, 0x51, 0xdf, 0xda, 0xc3, 0x44 } };

#include "imodule.h"


class ICrateDevice: public IDevice
{
public:
	virtual HRESULT STDMETHODCALLTYPE _PutModule(IModule* pModule, int nSlot) = 0;
	virtual HRESULT STDMETHODCALLTYPE iReadFlash(int nSlot, int nAddr, int nSize, byte* pData) = 0;
	virtual HRESULT STDMETHODCALLTYPE iWriteFlash(int nSlot, int nAddr, int nSize, byte* pData) = 0;
};


// {D403A886-504D-4510-9F84-33DE74359A2A}
static const GUID IID_IDevEntity = 
{ 0xd403a886, 0x504d, 0x4510, { 0x9f, 0x84, 0x33, 0xde, 0x74, 0x35, 0x9a, 0x2a } };

class IDevEntity: public IUnknown
{
public:
};


#endif

