#ifndef IPIDMOD_H
#define IPIDMOD_H


// {E3B71504-7713-4991-A6DD-AB6029776BDD}
extern GUID IID_IPidModule;


enum
{
	PCM_MANUAL,
	PCM_CHANNEL,
	PCM_PIDOUT
};

enum{
	PIDPROP_X,
	PIDPROP_Y,
	PIDPROP_E,
	PIDPROP_MODE_DSTY
};

class IPidModule : public IUnknown
{
	public:
		//   
		virtual HRESULT STDMETHODCALLTYPE SetInputChannel(HANDLE hCh)=0;

		//   
		virtual HRESULT STDMETHODCALLTYPE SetOutputChannel(HANDLE hCh)=0;

		//   
		//    
		virtual HRESULT STDMETHODCALLTYPE SetLevelControlMode(ULONG uMode)=0;

		// PIDLCM_MANUAL   
		virtual HRESULT STDMETHODCALLTYPE SetLevelValue(double dblLevel)=0;

		// PIDLCM_CHANNEL     
		virtual HRESULT STDMETHODCALLTYPE LinkLevelChannel(HANDLE hCh)=0;

		// PIDLCM_PIDOUT     pid-
		virtual HRESULT STDMETHODCALLTYPE LinkLevelPidOut(HANDLE hCh)=0;

		//  
		virtual HRESULT STDMETHODCALLTYPE SetFactor(int nIndex, double dblFactor)=0;

		//    pid
		virtual HRESULT STDMETHODCALLTYPE SetFactorsNumber(int nNumber)=0;

		virtual HRESULT STDMETHODCALLTYPE SetType(long lType)=0;

		//   
		//           
		//   (IPidModuleProgramming::ReadEXY)
		virtual HRESULT STDMETHODCALLTYPE GetProperty(ULONG uPropID, VARIANT& vParam, int nIndex)=0;
		
		//   
		//        
		//      (IPidModuleProgramming::WriteEXY)

		virtual HRESULT STDMETHODCALLTYPE SetProperty(ULONG uPropID, VARIANT vParam, int nIndex)=0;


};
 

//   pid    
//   
// 
//  :
//     :
//     IPidModule::SetXXX
//        :
//     IPidModuleProgramming::Programming
//
//  :
// 
//     
//     IPidModule::SetXXX
//     IPidModule::SetYYY
//     IPidModule::SetZZZ
//        
//     IPidModuleProgramming::ProgrammingProperties

// {2312BBCE-C3AB-4c47-8AAA-B4326FAA754C}
extern GUID IID_IPidModuleProgramming;

class IPidModuleProgramming : public IUnknown
{
	public:

		//   
		virtual HRESULT STDMETHODCALLTYPE ProgrammingLevelValue()=0;

		//  
		virtual HRESULT STDMETHODCALLTYPE ProgrammingFactor(int nIndex)=0;

		//   
		virtual HRESULT STDMETHODCALLTYPE ProgrammingProperties()=0;

		//   
		virtual HRESULT STDMETHODCALLTYPE ProgrammingAllFactors()=0;

		//     
		virtual HRESULT STDMETHODCALLTYPE WriteEXY()=0;
		//     
		virtual HRESULT STDMETHODCALLTYPE ReadEXY()=0;


};

#endif