#ifndef _DEV_PROPERTY_H
#define _DEV_PROPERTY_H

#include "Device.h"
#include "atlbase.h"
#include <vector>
using namespace std;

inline BOOL GetDevPropertyStr(HANDLE _hDev, CString* _pStr, long _PropType, long _SubProp=-1)
{
	VARIANT a_Value={VT_EMPTY};
	if (_hDev==NULL) return FALSE;
	Device* pDev=(Device*) _hDev;
	HRESULT Result=pDev->GetProperty(_PropType, a_Value, _SubProp, 0);
	if (a_Value.vt!=VT_BSTR || Result!=S_OK) {
		*_pStr="";
		return FALSE;
	} else {
		*_pStr=a_Value.bstrVal;
		SysFreeString(a_Value.bstrVal);
		return TRUE;
	}
}
inline BOOL SetDevPropertyStr(HANDLE _hDev, CString _pStr, long _PropType, long _SubProp=-1)
{
	CComVariant a_Value(_pStr);
	if (_hDev==NULL) return FALSE;
	Device* pDev=(Device*) _hDev;
	if (pDev->SetProperty(_PropType, a_Value, _SubProp, 0)==S_OK) return TRUE;
	else return FALSE;
}

inline BOOL GetDevPropertyLong(HANDLE _hDev, long* _pVal, long _PropType, long _SubProp=-1)
{
	VARIANT a_Value={VT_EMPTY};
	if (_hDev==NULL){
		return FALSE;
	}
	Device* pDev=(Device*) _hDev;
	HRESULT Result=pDev->GetProperty(_PropType, a_Value, _SubProp, 0);
	if (a_Value.vt==VT_EMPTY || Result!=S_OK) {
		*_pVal=0;
		return FALSE;
	} 
	else {
		CComVariant Var(a_Value);
		Var.ChangeType(VT_I4);
		*_pVal= Var.lVal;
		return TRUE;
	}
}

inline BOOL SetDevPropertyLong(HANDLE _hDev, long _Val, long _PropType, long _SubProp=-1)
{
	VARIANT a_Value;
	a_Value.vt=VT_I4;
	a_Value.lVal=_Val;
	if (_hDev==NULL) return FALSE;
	Device* pDev=(Device*) _hDev;
	if (pDev->SetProperty(_PropType, a_Value, _SubProp, 0)==S_OK) return TRUE;
	else return FALSE;
}

inline BOOL GetDevPropertyDbl(HANDLE _hDev, double* _pVal, long _PropType, long _SubProp=-1)
{
	VARIANT a_Value={VT_EMPTY};
	if (_hDev==NULL) return FALSE;
	Device* pDev=(Device*) _hDev;
	HRESULT Result=pDev->GetProperty(_PropType, a_Value, _SubProp, 0);
	if (a_Value.vt==VT_EMPTY || Result!=S_OK) {
		*_pVal=0.0;
		return FALSE;
	} else {
		*_pVal=a_Value.dblVal;
		return TRUE;
	}
}

inline BOOL SetDevPropertyDbl(HANDLE _hDev, double _Val, long _PropType, long _SubProp=-1)
{
	VARIANT a_Value;
	a_Value.vt=VT_R8;
	a_Value.dblVal=_Val;
	if (_hDev==NULL) return FALSE;
	Device* pDev=(Device*) _hDev;
	if (pDev->SetProperty(_PropType, a_Value, _SubProp, 0)==S_OK) return TRUE;
	else return FALSE;
}

#endif // _DEV_PROPERTY_H