#ifndef PROPERTYPAGESREGISTRY_H
#define PROPERTYPAGESREGISTRY_H
#include <unknwn.h>
#include <ocidl.h>
#include "IPropertyPageFactory.h"


// {EBD5C62C-ED36-46db-9A7B-02DDF9B53F2A}
extern const GUID IID_IPropertyPagesRegistry;


class IPropertyPagesRegistry : public IUnknown
{
public:
	virtual HRESULT STDMETHODCALLTYPE RegisterFactory(GUID id, IPropertyPageFactory* pFactory) = 0;
	virtual HRESULT STDMETHODCALLTYPE UnregisterFactory(GUID id) = 0;
	virtual HRESULT STDMETHODCALLTYPE Search(const GUID& id) const = 0;
	virtual HRESULT STDMETHODCALLTYPE CreatePage(GUID id, IPropertyPage** ppPage, ULONG nParams) = 0;
};
#endif
