#ifndef _PROPERTY_
#define _PROPERTY_

#define OBJ_TYPE_SYSTEM     1
#define OBJ_TYPE_RESOURCE   2 // DM, PM, MC_DM, MC_PM, MC_CFG
#define OBJ_TYPE_ADC        3 //   (   )
#define OBJ_TYPE_ICPSUB     4 /* ICP Submodule */
#define OBJ_TYPE_MAC        5 //   MAC-300
#define OBJ_TYPE_UST_OPT    6 //   
#define OBJ_TYPE_ALERT_OPT  7 //    
#define OBJ_TYPE_ME908_CHAN 8 //   Me908
#define OBJ_TYPE_ME908      9 //  Me908

#define MAX_OBJECTS_TYPES_CNT 9 //      (TCommonObjVTBL)  ADSP

/* Some properties use type of channel in 'iChan' field (PRP_BUFFER) */
#define TYPE_CHAN_AIN  0
#define TYPE_CHAN_AOUT 1
#define TYPE_CHAN_DIN  2
#define TYPE_CHAN_DOUT 4
#define TYPE_CHAN_TECH 8

/********************* Result (0-16) *************************/
#define PRP_OK             0     /* Sucessfull return */
#define PRP_UNKNOWN        1     /* Unknown Property */
#define PRP_UNDEFINED      2     /* Known, but undefined yet (retry later) */
#define PRP_TIMEOUT_ERROR  3     /* Timeout error */

/********************* System Property (100-500) *************************/
#define PRP_BIOS_PATH      4345

/********************* Common Property (500-2000) ************************/
#define PRP_NAME           4203  /* R/W Name of object */
#define PRP_ID             4301
#define PRP_INFO           4204  /* Info about an object */
#define PRP_SN             4315
#define PRP_REV            4316
#define PRP_TYPE           4317
#define PRP_BUS            4318
#define PRP_ROUTE          4319

/********************* Device Property (2000-8000) *************************/
#define PRP_BIOS_REV       2000  /* BIOS Revision Number */
#define PRP_KERNEL_REV     2001  /* Kernel Revision Number {(WORD)Major, (WORD)Minor}*/
#define PRP_FLEX_REV       2002  /* Flex Revision Number {(WORD)Major, (WORD)Minor}*/
#define PRP_DSP_CLK_FREQ   2003  /* R DSP CLK Frequency, Hz */
#define ARGC_SIZE_PROPERTY  16    /* CallCommand argument buffer size */
#define ARGR_SIZE_PROPERTY 2005   /* CallCommand returns buffer size */
#define nAInChan_PROPERTY   256   /* Analog Input Channels number */
#define nDInChan_PROPERTY   1024  /* Digital Input Channels number */
#define nDOutChan_PROPERTY  768   /* Digital Output Channels number */
#define PRP_HADC_CNTR      2004  /* R Current HADC Counter */

#define nAInGroups_PROPERTY 257   /* ⢮ ६ ࠡ  ⨧樨   */

#define OverLoad0_PROPERTY  272   /* Overload 0  */
#define OverLoad1_PROPERTY  273   /* Overload 1  */

#define PRP_BOOT_SIZE      4200  /* */
#define PRP_RESOURCE       4201  /* Transfer Resource */
#define PRP_ROOTHUB        4202  /* HANDLE to Root Hub */
#define PRP_MC_SLOT_NO     4220

#define PRP_MDP            4205
#define PRP_PRESENT        4206
#define PRP_ONLINE         4207
#define PRP_COMM_PORT      4239
#define PRP_COMM_BAUD      4240
#define PRP_COMM_DATA      4241
#define PRP_COMM_STOP      4242
#define PRP_COMM_PARITY    4243
#define PRP_COMM_INQUEUE   4244
#define PRP_COMM_OUTQUEUE  4245
#define PRP_COMM_ECHO      4246

#define PRP_CUR_CMD_ITEM   4247
#define PRP_SLAVE_IDX      4248

#define PRP_RELOAD_BIOS    4208
#define PRP_RELOAD_FLEX    4209

#define PRP_SIZE           4210  /* size of something in bytes */
#define PRP_WORD_SIZE      4211  /* word size in bytes */
#define PRP_ADDR_INFO      4212  /* Address information of resource */
#define PRP_RES_DISABLE    4213  /* Disable resource */

#define PRP_ADDRESS_STR    4303

#define PRP_ADSP_FIFO_SIZE 4309
#define PRP_CHAN           4313
#define PRP_CHAN_CNT       4314
#define PRP_BUFFER_CNT     4342
#define PRP_CHANGE_CHAN    4343

#define PRP_CTRL_REG       4361
#define PRP_STOP           4352

/********** Internal Digital Buses *************/
#define PRP_PXI_MASTER      2200  /* PXI lines Mastering (0-Z state, 1-drive) */
#define PRP_PXI_REG         2201  /* Value of PXI register (0-"0", 1-"1") */
#define PRP_PXI_LINE        2202  /* Value of PXI register (0-"0", 1-"1") */
#define PRP_PXI_SEL         2210

#define PRP_CLK_SOURCE      2211  /* CLK Source for DAQ-circuits */

#define PRP_RUN            4346
#define PRP_SYNTEZ         4348  /* W Analog output (will be replaced by AOutChannel properties) */
#define PRP_SYNTEZ_FS      4349  /* W  */
#define PRP_SYNTEZ_AMPL    4350  /* W  */

#define PRP_ADC_CALIBR     4351  /* W  */
#define PRP_HADC           4353  /* R  */
#define PRP_HCLK           4354  /* R  */

// Visual
#define PRP_SHOW_ESTIM     4370
#define PRP_CUR_CHAN       4371
#define PRP_VIEW_MODE      4372  /* Viewing Mode */
#define PRP_ESTIM_SHOW_T   4373  /* Estimation show delay */

#define PRP_EXTERNAL       8120  /* External device present */
#define PRP_EXT_REV        8121  /* External device revision number */
#define PRP_EXT_SN         8127  /* External device serial number */

#define PRP_PFI             4400  /* PFI state */

#define PRP_SCXI            4360  /* R/W; SCXI-bus state */

/*  ! */
#define PM_BEG_PROPERTY     7800  /* 砫  PM ADSP */
#define PM_LEN_PROPERTY     7801  /*    PM ADSP */
#define DM_BEG_PROPERTY     7802  /* 砫  DM ADSP */
#define DM_LEN_PROPERTY     7803  /*    DM ADSP */

#define PRP_MC_DM_LEN       7815  /* MC-Module data memory length */
#define PRP_MC_PM_LEN       7816  /* MC-Module program memory length */
#define PRP_MC_CFG_LEN      7817  /* MC-Module config flash length */

#define VREF_PROPERTY       7804  /* ୮ 殮     */
#define CHAN_AMPL_PROPERTY  7808
#define CHAN_ATT_PROPERTY   7809
#define CHAN_HPF_PROPERTY   7810
#define CHAN_LPF_PROPERTY   7811
#define nAOutChan_PROPERTY  7812  /* ⢮ 室  */
#define IS_MODULE_PROPERTY  7813  /* 1 - , 0 -  */
#define REVISION_PROPERTY   262  /* Revision number       */
#define PRP_INT_MEM_EXT     7814 /* Memory of external amplifyer */
#define PRP_RECEIVE_LOG     7820 /* Save input stream to log-file*/
#define PRP_TRANSFER_LOG    7821 /* Save output stream to log-file*/

#define PRP_DEBUG_0         7900 /* Debug variable 0 */
#define PRP_DEBUG_1         7901 /* Debug variable 1 */
#define PRP_DEBUG_2         7902 /* Debug variable 2 */
#define PRP_DEBUG_3         7903 /* Debug variable 3 */
#define PRP_DEBUG_4         7904 /* Debug variable 4 */

/********************* Channel Property (8000-20000) ************************/

#define PRP_ASYNC          4300  /* R/W Asyncronous */
#define PRP_INDEX          4302  /* 0-based channel index */

/* Events */
#define PRP_TRANSFER_CTX   8010  /* Context of transfer task */

/* Timing */
#define PRP_HANDLER        4304  /* Event Handler */
#define PRP_HANDLER_DATA   4305  /* User Data 1 for Handler */
#define PRP_HANDLER_PARAM  4306  /* User Data 2 for Handler */
#define PRP_T_OVER         4307  /* Cache size */
#define PRP_T_EVENT        4308  /* fragment size for user Handler */

#define PRP_INPIN_HANDLE   8030
#define PRP_OUTPIN_HANDLE  8031

/* Static Acquisition Properties */
#define PRP_VT             8020 /* R/W Channel Resolution, y=k1(x-k0) */
#define PRP_K1             8021 /* R/W Channel Resolution, y=k1(x-k0) */
#define PRP_K0             8022 /* R/W Zero offset, y=k1(x-k0)   */
#define PRP_K0_FULL        8023 /* R/W Zero offset, y=k1(x-k0)   */
#define PRP_LSB_WEIGHT     8024 /* R/W  = k1 */

#define PRP_BALDAC_K1      4401 /* R/W Balance DAC Resolution Res=U/kod */
#define PRP_ZR_OFFSET      4311 /* R/W Balance DAC value, V */

#define PRP_FS             4312 /* R/W Sampling frequency, Hz */
#define PRP_FS_INDEX       4331
#define PRP_INPUT_SWITCH   4344 /* Input Switch */

#define PRP_RANGE          4330 /* */
#define PRP_RANGE_INDEX    4332
#define PRP_LPF            4333
#define PRP_HPF            4334
#define PRP_FS_CHANGED     4340
#define PRP_BUFFER         4341
#define PRP_ANALOG_POWER   4355
                                 /* External device properties (charge amplifier) */
#define PRP_LPF_EXT        8110  /* Cutoff frequency of external LPF */
#define PRP_LPF_CNT_EXT    8112  /* Number of external LPF */
#define PRP_HPF_EXT        8111  /* Cutoff frequency of external HPF */
#define PRP_HPF_CNT_EXT    8113  /* Number of external HPF */
#define PRP_RANGE_EXT      8122  /* Amplitude range of external device */
#define PRP_SELFTEST_EXT   8123  /* External device selftest */
#define PRP_RANGE_CNT_EXT  8124  /* Number of amplitude ranges of external device */
#define PRP_K1_EXT         8125  /* R/W */
#define PRP_CHANGE_EXT     8126
#define PRP_OPERATOR_EXT   8136
#define PRP_CAL_DATE_EXT   8137

#define PRP_TAR_POLE       4130  /* One nome of interpolate polinome */
#define PRP_F_MID_FACTOR   4131  /*        */
#define PRP_DECIM_BUF      4140  /* Decim task Buffer */

#define PRP_ALERT_ESTIM    8140  /* Alerts */
#define PRP_ALERT_COND     8146  /* Alert conditions */
#define PRP_ALERT_PROC     8147  /* Alert Activation Processing (HANDLE) */
#define PRP_WARNING_OPTS   8148  /* Index of named option's-set */
#define PRP_CRASH_OPTS     8149  /* Index of named option's-set */

#define PRP_WARN_LEVEL     8141  /* Warning Level */
#define PRP_CRASH_LEVEL    8142  /* Crash Level */

#define PRP_LEVEL_TOP      8143  /* Top Level */
#define PRP_LEVEL_BOT      8144  /* Bottom Level */

#define PRP_DIN            8150  /* State on digital inputs (channels No=0...15) */

/* Signal Processing Options */
#define PRP_IIR_OPT        8210  /* IIR-Filter Options (struct) */
#define PRP_FIR_OPT        8211  /* FIR-Filter Options (struct) */
#define PRP_FILTER_K       8212  /* Filter Factors. Var[0]=PRP_FILTER_K; Var[1]=iOrder; Var[2]=aA0 ... */
#define PRP_INTEGR_OPT     8220  /* Integration Options (struct) */

/* Dynamic Acquisition Properties */
#define PRP_CURSOR         4347

#define PRP_MO             4100  /* M.O. estimation of channel                                */
#define PRP_MEAN           PRP_MO /* Mean */
#define PRP_MAX_MIN        4101  /* Max, Min estimation of channel                            */
#define PRP_SKZ            4102  /* SKZ estimation of channel                                 */
#define PRP_RMS            PRP_SKZ /* RMS */
#define PRP_SKO            4103  /* SKO estimation of channel                                 */
#define PRP_RMSE           PRP_SKO /* RMSE */
#define PRP_F              4104  /* frequency estimation of channel                      */
#define PRP_PEAK           4105  /* amplitude */
#define PRP_PEAKPEAK       4106  /* peak-peak */

#define PRP_M_F            4110
#define PRP_A_F            4111
#define PRP_SKO_F          4112  /* SKO estimation of channel                                 */
#define PRP_SKZ_F          4113  /* SKO estimation of channel                                 */
#define PRP_P_F            4114  /* SKO estimation of channel                                 */

#define PRP_M_F_SUM        4120
#define PRP_A_F_SUM        4121
#define PRP_SKO_F_SUM      4122  /* SKO estimation of channel                                 */
#define PRP_SKZ_F_SUM      4123  /* SKO estimation of channel                                 */

#define PRP_HARM           PRP_A_F  /* Harmonic estimation of channel                            */

#define PRP_ICP_ON         4124  /* 1=ICP Mode On; 0=ICP Mode Off */
#define PRP_ICP_HPF        4125  /* 1=ICP HPF On; 0=ICP HPF Off */
#define PRP_SINGLE         4126  /* 1=Single Ended Input Mode; 0=Differential Input Mode  */

#define PRP_INTEGRAL       8130  /* Integration of signal */

/* Old */
#define bDInAsync_PROPERTY  1536 /* ⨥  . ஢ ᨭ.                     */

#endif // _PROPERTY_
