/******************************************************************************/
/*  Recorder                                                                  */
/*  TRANSF\                                                                   */
/*    ITransformer                                          */
/*                                                 */
/*                                                                            */
/*    : itransf.h                                             */
/*  : MVC++6.0                                                      */
/*                                                                            */
/*  (c)  "" 2001, 2002 .                                             */
/******************************************************************************/


#ifndef ITRANSF_H
#define ITRANSF_H

#include "datastat.h"

typedef enum{
	TXT_NULL, TXT_SCALE, TXT_LINE, TXT_INTEPOLATETABLE, TXT_POLYNOME, TXT_MULTI
}TXTYPE;



///  
enum{
  TXN_UPDATELINKS,   //  
  TXN_UPDATEDB       //   
};


///     
const int IDCTF_UPDATEHARDWTARE = 0x0555;


// {C1A20401-DC60-11d6-9243-00E029288A7F}
extern const GUID IID_ITransformer;


/// @interface ITransformer   
class ITransformer: public IUnknown
{
public:
	virtual HANDLE      STDMETHODCALLTYPE GetEditor()=0;
	virtual HANDLE      STDMETHODCALLTYPE GetEmbeddedEditor(HANDLE a_pParent=NULL)=0;

	///       a_pStream==NULL
	///   
	virtual int         STDMETHODCALLTYPE Save(HANDLE a_pStream)=0;
	///       a_pStream==NULL
	///   
	virtual int         STDMETHODCALLTYPE Load(HANDLE a_pStream)=0;

	///        .mera
	virtual int         STDMETHODCALLTYPE GetInfoStrings(int* a_pnIndex, char* a_pchBuffer, const char* a_pchPath, const char* a_pchTagName)=0;
	virtual BOOL        STDMETHODCALLTYPE Edit()=0;

	///       
	virtual double      STDMETHODCALLTYPE Eval(double a_dblValue)=0;
	virtual TXTYPE      STDMETHODCALLTYPE GetTXType()=0;
	virtual HRESULT     STDMETHODCALLTYPE UpdateEditor()=0;
	virtual HRESULT     STDMETHODCALLTYPE Reset()=0;

	virtual DWORD       STDMETHODCALLTYPE GetName(char* a_pchName)=0;
	virtual HRESULT     STDMETHODCALLTYPE SetName(const char* a_pchName)=0;

	///    .csv
	virtual HRESULT     STDMETHODCALLTYPE ImportFromFile(const char* a_pchName, const char* a_pchSeparator)=0;
	///    .csv
	virtual HRESULT     STDMETHODCALLTYPE ExportToFile(const char* a_pchName, const char* a_pchSeparator)=0;

	virtual LPCSTR      STDMETHODCALLTYPE GetProgID() = 0;

	///   
	virtual DWORD       STDMETHODCALLTYPE GetTypeName(char* a_pchName) = 0;

	///    
	virtual HRESULT     STDMETHODCALLTYPE Check()=0;

	///  
	virtual HRESULT     STDMETHODCALLTYPE GetProperty(DWORD a_dwPropertyID, VARIANT& a_Value) = 0;
	///  
	virtual HRESULT     STDMETHODCALLTYPE SetProperty(DWORD a_dwPropertyID, VARIANT a_Value)=0;

	///  /
	virtual bool        STDMETHODCALLTYPE Notify(DWORD a_dwCommand, DWORD a_dwParam)=0;

	///      
	virtual bool        STDMETHODCALLTYPE TestImportFile(LPCSTR a_pchName)=0;

	///     TX
	virtual double      STDMETHODCALLTYPE EvalInverse(double a_dblValue)=0;

	///       
	virtual const char* STDMETHODCALLTYPE GetDefaultCalibrPath()=0;
	///       
	virtual void        STDMETHODCALLTYPE SetDefaultCalibrPath(const char* a_pchPath)=0;

	///      
	virtual DWORD       STDMETHODCALLTYPE GetLastEvalState() const = 0;

	///       IMeScales
	virtual HRESULT     STDMETHODCALLTYPE Attach(IUnknown* a_pUnk) = 0;
};
#endif
