#ifndef TFIFACE_H
#define TFIFACE_H

class IScale : public IUnknown
{
  public:
    virtual HRESULT STDMETHODCALLTYPE PutScale(double a_dblValue)PURE;
    virtual HRESULT STDMETHODCALLTYPE GetScale(double* a_pdblValue)PURE;
};


// {5B40FDE1-DC62-11d6-9243-00E029288A7F}
extern const GUID CLSID_InterpolateTransformer;

// {27F2BF6E-DCDD-4d65-8EB7-1DA4AE36F7B6}
extern const GUID CLSID_InterpolateTransformer2;

// {509B9202-DC77-11d6-9243-00E029288A7F}
extern const GUID IID_IInterpolate;

class IInterpolate : public IUnknown
{
  public:
    virtual HRESULT STDMETHODCALLTYPE SetNode(double a_dblValX, double a_dblValY, int a_nIndex=-1)PURE;
    virtual HRESULT STDMETHODCALLTYPE GetNode(double* a_pdblValX, double* a_pdblValY, int a_nIndex=-1)PURE;
    virtual ULONG   STDMETHODCALLTYPE GetNodesCounter()PURE;
    virtual HRESULT STDMETHODCALLTYPE SetExtrapolateMode(BOOL  a_fExtrapolate)PURE;
    virtual BOOL    STDMETHODCALLTYPE GetExtrapolateMode()PURE;
};

// {863D3121-8564-11d7-9244-00E029288A7F}
extern const GUID IID_ILinear;

class ILinear : public IUnknown
{
  public:
    virtual HRESULT STDMETHODCALLTYPE PutA(double a_dblA)PURE;
    virtual HRESULT STDMETHODCALLTYPE PutB(double a_dblB)PURE;
    virtual HRESULT STDMETHODCALLTYPE GetA(double* a_pdblA)PURE;
    virtual HRESULT STDMETHODCALLTYPE GetB(double* a_pdblB)PURE;
};

// {2ACAF761-FF20-11d7-9244-00E029288A7F}
extern const GUID IID_IPolynomial;

class IPolynomial : public IUnknown
{
  public:
    virtual HRESULT STDMETHODCALLTYPE SetPower(ULONG a_nPower)PURE;
    virtual ULONG   STDMETHODCALLTYPE GetPower()PURE;
    virtual HRESULT STDMETHODCALLTYPE PutCoefficient(double a_dblCoefficient, int a_nIndex)PURE;
    virtual HRESULT STDMETHODCALLTYPE GetCoefficient(double* a_pdblCoefficient, int a_nIndex)PURE;
};


// {5B40FDE0-DC62-11d6-9243-00E029288A7F}
extern const GUID CLSID_ScaleTransformer;


// {BF74BEDA-0961-4c01-95A8-FC927E2D4E4A}
extern const GUID CLSID_ScaleTransformer2;


// {5B40FDE1-DC62-11d6-9243-00E029288A7F}
extern const GUID CLSID_InterpolateTransformer;

// {27F2BF6E-DCDD-4d65-8EB7-1DA4AE36F7B6}
extern const GUID CLSID_InterpolateTransformer2;


// {C1A20401-DC60-11d6-9243-00E029288A7F}
extern const GUID IID_ITransformer;

// {509B9201-DC77-11d6-9243-00E029288A7F}
extern const GUID IID_IScale;

// {509B9202-DC77-11d6-9243-00E029288A7F}
extern const GUID IID_IInterpolate;

// {863D3122-8564-11d7-9244-00E029288A7F}
extern const GUID CLSID_LinearTransformer;

// {488D8974-C611-4818-AC46-33E486DBF354}
extern const GUID CLSID_LinearTransformer2;


// {863D3121-8564-11d7-9244-00E029288A7F}
extern const GUID IID_ILinear;

// {2ACAF762-FF20-11d7-9244-00E029288A7F}
extern const GUID CLSID_PolynomialTransformer;


// {DBB3886D-D29D-4c1b-A46B-C9ED6EDA285E}
extern const GUID CLSID_PolynomialTransformer2;


// {2ACAF761-FF20-11d7-9244-00E029288A7F}
extern const GUID IID_IPolynomial;

// {2538D2CE-BFA7-4abb-B071-D12B40518330}
extern const GUID CLSID_LinkScaleTransformer;


#endif