#ifndef IBUSDRIVER_H
#define IBUSDRIVER_H
#include "mebase.h"
#include "Utils/mestring.h"
#include "IDevApi.h"
#include "IBus.h"
#include "IDevApiRegistry.h"

namespace mebius_daq{
//using namespace mebase;
using mebase::MEBRESULT;
using mebase::BUSID;
using mebase::system::mestring;
///       

class IMebiusDaq;
class IBus;

class IBusDriver
{
public:

	virtual MEBRESULT MEBCALLTYPE Init(IMebiusDaq* pDARTC) = 0;
	virtual MEBRESULT MEBCALLTYPE Uninit() = 0;	
	virtual MEBRESULT MEBCALLTYPE CreateBus(IBus** pBus)=0;
	virtual MEBRESULT MEBCALLTYPE DestroyBus(IBus* pBus)=0;
	virtual MEBRESULT MEBCALLTYPE GetBusID(BUSID* pID)=0;
	virtual MEBRESULT MEBCALLTYPE GetBusName(mestring& bus_name)=0;

};

}

#endif
