#ifndef IDEVICEINFO_H
#define IDEVICEINFO_H

#include "IDeviceDriver.h"
#include "mebase.h"
#include "mestring.h"
#include "IBus.h"

namespace mebius_daq{

using mebase::system::mestring;
using mebase::MEBRESULT;
class IDeviceDriver;
class IBus;

/// @interface IDeviceInfo 
///   .    .
class IDeviceInfo
{
public:

	///    
	virtual MEBRESULT MEBCALLTYPE GetAddress(
			mestring& msAddres ///< [out]  
		) const = 0;

	virtual MEBRESULT MEBCALLTYPE GetBus(
			IBus** pBus
		) const = 0;
	
	///    
	virtual MEBRESULT MEBCALLTYPE GetDeviceClassId(
			mebase::DEVICECLASSID* pClassID ///< [out]   
		) const = 0;
	
	///    
	virtual MEBRESULT MEBCALLTYPE GetDeviceVendorID(
			mebase::ULONG* pnVendorID ///< [out]   
		) const = 0;
	
	///    
	virtual MEBRESULT MEBCALLTYPE GetDeviceSerial(
			mebase::ULONG* pnSerial ///< [out]   
		) const = 0;
	
	///   
	virtual MEBRESULT MEBCALLTYPE GetDeviceInfoBits(
			mebase::ULONG* pInfo, ///< [out]      
			mebase::ULONG nReserved ///<[in] 
		) const = 0;

	
	///     
	virtual MEBRESULT MEBCALLTYPE GetDeviceDriver(
			IDeviceDriver** pDriver ///< [out]    
		) const = 0;
};
}
#endif
