#ifndef I_MEB_DEVICE_TEST_H
#define I_MEB_DEVICE_TEST_H

#include "mebase.h"
#include "IObject.h"

namespace mebius_daq{

/// @interface IMebDeviceTest
class IMebDeviceTest : public IObject
{
public:	
	///   
	virtual MEBRESULT STDMETHODCALLTYPE InitializeTest() = 0;
	
	///   
	virtual MEBRESULT STDMETHODCALLTYPE FinalizeTest() = 0;
	
	///   
	virtual mebase::ULONG   STDMETHODCALLTYPE GetTestStepsCount() = 0;
	
	///   
	/// a_nStepIndex      -  
	/// a_pchNameBuff     -     
	/// mebase::ULONG a_nBuffLen  -  
	virtual MEBRESULT STDMETHODCALLTYPE GetTestStepName(mebase::ULONG nStepIndex, char* pchNameBuff, mebase::ULONG nBuffLen) = 0;
	
	///   
	/// a_nStepIndex      -  
	/// a_pchDescribeBuff -     
	/// mebase::ULONG a_nBuffLen  -  
	virtual MEBRESULT STDMETHODCALLTYPE GetTestStepDescribe(mebase::ULONG nStepIndex, char* pchDescribeBuff, mebase::ULONG nBuffLen) = 0;
	
	///     
	/// a_nStepIndex      -  
	virtual MEBRESULT STDMETHODCALLTYPE PrepareTestStep(mebase::ULONG nStepIndex) = 0;

	///    
	/// a_nStepIndex      -  
	/// a_pchPromptBuff   -     
	/// mebase::ULONG a_nBuffLen  -  
	virtual MEBRESULT STDMETHODCALLTYPE GetTestStepPrompt(mebase::ULONG nStepIndex, char* pchPromptBuff, mebase::ULONG nBuffLen) = 0;
   
	///   
	/// a_nStepIndex      -  
	/// a_pchResultInfo   -       
	/// mebase::ULONG a_nBuffLen  -  
	virtual MEBRESULT STDMETHODCALLTYPE RunTestStep(mebase::ULONG a_nStepIndex, char* a_pchResultInfo, mebase::ULONG a_nBuffLen, DWORD *result) = 0;
};

}
#endif
