#ifndef INETWORKSETTINGS_H
#define INETWORKSETTINGS_H

#include <mebase.h>
#include <mestring.h>
#include "MebiusDAQ/iface/IObject.h"


using mebase::system::mestring;

namespace mebius_daq{

const mebase::ULONG MEBIID_INetworkSettings = 0x00001;

struct NETWORK_SETTINGS 
{
	
};

/// @interface INetworkSettings
class INetworkSettings : public IObject
{
public:
	
	///  ip  	
	virtual MEBRESULT MEBCALLTYPE SetIP(const mestring& msAddress) = 0;
	
	///  ip  	
	virtual MEBRESULT MEBCALLTYPE GetIP(mestring& msAddress) const = 0;


	///   ip  	
	virtual MEBRESULT MEBCALLTYPE SetMask(const mestring& msMask) = 0;
	
	///   ip  	
	virtual MEBRESULT MEBCALLTYPE GetMask(mestring& msMask) const = 0;


	///  MAC  	
	virtual MEBRESULT MEBCALLTYPE SetMAC(mebase::ULONGLONG mac) = 0;
	
	///  MAC  	
	virtual MEBRESULT MEBCALLTYPE GetMAC(mebase::ULONGLONG& mac) const = 0;

	///   	
	virtual MEBRESULT MEBCALLTYPE SetConnectionPort(mebase::LONG port) = 0;
	
	///   	
	virtual MEBRESULT MEBCALLTYPE GetConnectionPort(mebase::LONG& port) const = 0;


	///   gateway 	
	virtual MEBRESULT MEBCALLTYPE SetGateway(const mestring& msAddress) = 0;
	
	///   gateway 	
	virtual MEBRESULT MEBCALLTYPE GetGateway(mestring& msAddress) const = 0;



	///    
	virtual MEBRESULT MEBCALLTYPE Burn() = 0;
};

}

#endif
