#ifndef IRESOURCE_H
#define IRESOURCE_H

#include <mebase.h>
#include <mestring.h>
#include "IObject.h"




using mebase::system::mestring;

namespace mebius_daq{


///  
enum{
	MEDEVRESRTYPE_STREAM_ACCESS = 0x00001, ///   
	MEDEVRESRTYPE_RANDOM_ACCESS = 0x00002, ///  
	MEDEVRESRTYPE_READ          = 0x00100, ///  
	MEDEVRESRTYPE_WRITE         = 0x00200  ///  

};

/// @interface IResource
class IResource
{
public:

	///  
	virtual MEBRESULT MEBCALLTYPE GetName(mestring& msName) = 0;

	///  
	virtual MEBRESULT MEBCALLTYPE GetType(mebase::ULONG& nType) = 0;


	///  
	virtual MEBRESULT MEBCALLTYPE Open(void** ppInterface) = 0;

	///  
	virtual MEBRESULT MEBCALLTYPE Close() = 0;
};



/// @interface IRandomAccessIoResource
class IRandomAccessIoResource
{
public:
	virtual MEBRESULT MEBCALLTYPE GetSize(mebase::ULONGLONG* pSize) = 0;
	virtual MEBRESULT MEBCALLTYPE Read(mebase::ULONGLONG nPos, mebase::BYTE* pBuffer, mebase::ULONG size, mebase::ULONG& readed) = 0;
 	virtual MEBRESULT MEBCALLTYPE Write(mebase::ULONGLONG nPos, mebase::BYTE* pBuffer, mebase::ULONG size, mebase::ULONG& written) = 0;
};

}


#endif
