#ifndef PROPIDBASE_H
#define PROPIDBASE_H
#include "mebase.h"

///     

///


///   
#define MAKE_DEVICE_TYPEID(classid, spec) \
    ((mebase::ULONG)((0xFE000000&((mebase::ULONG)(classid)<<25)) | (((mebase::ULONG)(spec)<<16) & 0x01FF0000)))

///  ,    (  )    
#define MAKE_DEVICEID(typeid, spec) \
    ((mebase::ULONG)((0xFFFF0000&typeid)|(0x0000FFFF&spec)))

///  ,    (  ),   (. )       (   )
#define MAKE_BUSID(busId, physAddr, slotNum) \
    ((mebase::ULONG)((0x0000FFFF&busId)|(0x00FF0000&(physAddr << 16))|(0xFF000000&(slotNum << 24))))

///   
#define GET_BUSTYPEID(Id) \
	((mebase::ULONG)(0x0000FFFF&Id))

///    
#define GET_BUS_PHYSADDR(Id) \
	((mebase::ULONG)(0x00FF0000&(Id>>16)))


///      
///       
#define GET_DEVICE_TYPEID(devid) \
	((mebase::ULONG)(0xFFFF0000 & (devid)) )

///      
///       .
#define GET_DEVICE_CLASS(devid) \
	((mebase::ULONG)(0xFFFF0000 & (devid)) >> 16 )



///    
#define MAKE_PROPID(classid, subtypeid, spec) \
	((mebase::ULONG)((0xFE000000&((mebase::ULONG)(classid)<<25)) | \
	(0x01FC0000&((mebase::ULONG)(subtypeid)<<18)) | \
	((mebase::ULONG)(spec)&0x0003FFFF))) 


namespace mebius_daq {
//using namespace mebase;

///  		
const mebase::ULONG DEV_CLASSID_M    = 0x0001;
const mebase::ULONG DEV_CLASSID_MB   = 0x0002;
const mebase::ULONG DEV_CLASSID_MC   = 0x0003;
const mebase::ULONG DEV_CLASSID_EMUL = 0x0004;
const mebase::ULONG DEV_CLASSID_MKO  = 0x0005;
const mebase::ULONG DEV_CLASSID_MR   = 0x0006;
const mebase::ULONG DEV_CLASSID_MD   = 0x0007;
const mebase::ULONG DEV_CLASSID_MRV2 = 0x0008;
const mebase::ULONG DEV_CLASSID_MS   = 0x0009;

///      (...)
const mebase::ULONG DEV_ID_SEV = 0;
const mebase::ULONG DEV_ID_SERVICE = 1;

const mebase::ULONG MEPROPCLASSID_BASE    = 0;
const mebase::ULONG MEPROPCLASSID_CHANNEL = 1;
const mebase::ULONG MEPROPCLASSID_MB      = 2;
const mebase::ULONG MEPROPCLASSID_MR      = 3;

///     
const mebase::ULONG MEPROPCLASSID_COMMUTATOR = 4;
const mebase::ULONG MEPROPCLASSID_MS         = 5;
const mebase::ULONG MEPROPCLASSID_CYCLOGRAM  = 6;

/// 
const mebase::USHORT MEPROPSUBCLASSID_MIC170    = 6;
const mebase::USHORT MEPROPSUBCLASSID_MIC1100   = 7;
const mebase::USHORT MEPROPSUBCLASSID_MIC170V3  = 8;
const mebase::USHORT MEPROPSUBCLASSID_MIC140    = 9;
const mebase::USHORT MEPROPSUBCLASSID_MIC183    = 10;
const mebase::USHORT MEPROPSUBCLASSID_MIC304    = 11;
const mebase::USHORT MEPROPSUBCLASSID_MIC1150   = 12;
const mebase::USHORT MEPROPSUBCLASSID_MIC170EMU = 13;
const mebase::USHORT MEPROPSUBCLASSID_MIC1500   = 14;
const mebase::USHORT MEPROPSUBCLASSID_MR2507    = 15;
const mebase::USHORT MEPROPSUBCLASSID_MIC170V4  = 16;
const mebase::USHORT MEPROPSUBCLASSID_VX753   = 17;
const mebase::USHORT MEPROPSUBCLASSID_MRBIOS  = 18;
const mebase::USHORT MEPROPSUBCLASSID_ME415  = 19;
const mebase::USHORT MEPROPSUBCLASSID_MIC170V5  = 20;

const mebase::ULONG MEDEVICETYPE_MIC170   = MAKE_DEVICE_TYPEID(DEV_CLASSID_M, MEPROPSUBCLASSID_MIC170);
const mebase::ULONG MEDEVICETYPE_MIC1100  = MAKE_DEVICE_TYPEID(DEV_CLASSID_M, MEPROPSUBCLASSID_MIC1100);
const mebase::ULONG MEDEVICETYPE_MIC170V3 = MAKE_DEVICE_TYPEID(DEV_CLASSID_M, MEPROPSUBCLASSID_MIC170V3);
const mebase::ULONG MEDEVICETYPE_MIC140   = MAKE_DEVICE_TYPEID(DEV_CLASSID_M, MEPROPSUBCLASSID_MIC140);
const mebase::ULONG MEDEVICETYPE_MIC183	  = MAKE_DEVICE_TYPEID(DEV_CLASSID_M, MEPROPSUBCLASSID_MIC183);
const mebase::ULONG MEDEVICETYPE_MIC304	  = MAKE_DEVICE_TYPEID(DEV_CLASSID_M, MEPROPSUBCLASSID_MIC304);
const mebase::ULONG MEDEVICETYPE_MR2507   = MAKE_DEVICE_TYPEID(DEV_CLASSID_M, MEPROPSUBCLASSID_MR2507);
const mebase::ULONG MEDEVICETYPE_MIC170EMU= MAKE_DEVICE_TYPEID(DEV_CLASSID_M, MEPROPSUBCLASSID_MIC170EMU);
const mebase::ULONG MEDEVICETYPE_MIC170V4 = MAKE_DEVICE_TYPEID(DEV_CLASSID_M, MEPROPSUBCLASSID_MIC170V4);
const mebase::ULONG MEDEVICETYPE_VX753    = MAKE_DEVICE_TYPEID(DEV_CLASSID_M, MEPROPSUBCLASSID_VX753);
const mebase::ULONG MEDEVICETYPE_ME415    = MAKE_DEVICE_TYPEID(DEV_CLASSID_M, MEPROPSUBCLASSID_ME415);
const mebase::ULONG MEDEVICETYPE_MIC170V5 = MAKE_DEVICE_TYPEID(DEV_CLASSID_M, MEPROPSUBCLASSID_MIC170V5);

}

typedef enum {
	MEPROP_VERSION                = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0,  1),
	MEPROP_NAME                   = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0,  2),
	MEPROP_SERIAL                 = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0,  3),
	MEPROP_OWNER_NAME             = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0,  4),
	MEPROP_DEVICE_INFO            = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0,  5),
	MEPROP_INITIALIZED            = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0,  6),
	MEPROP_DESCRIPTION            = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0,  7),
	MEPROP_RANGE_MIN              = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0,  8),
	MEPROP_RANGE_MAX              = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0,  9),
	MEPROP_INFORMATION            = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0, 10),
	MEPROP_UNITS                  = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0, 11),
	MEPROP_ALIAS                  = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0, 12),
	MEPROP_DEVICE_TYPE            = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0, 13),
	
	///    {R/O} 
	MEPROP_RANGE_STR              = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0, 14),
	
	///   {R/O}
	MEPROP_MODE_STR			      = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0, 15),
	//   () 
	MEPROP_MODE_ID                = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0, 16),
	MEPROP_RANGE_ID               = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0, 17),
	//   
	MEPROP_BALANCE_DAC            = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0, 18),
	MEPROP_SLOT                   = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0, 19),
	MEPROP_PORT                   = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0, 20),
	MEPROP_IP                     = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0, 21),
	MEPROP_IRQ_LINE               = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0, 22),
	MEPROP_START_TYPE		      = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0,  23),
	MEPROP_BUS_FREQ			      = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0,  24),
	MEPROP_BUS_FREQ_LIST	      = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0,  25),
	
	///    {R/O}
	///     
	
	MEPROP_HAVE_OUT_STREAM        = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0, 26),
	
	/// @bug
	MEPROP_NANDTEST			      = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0,  27),
	/// @bug
	MEPROP_SPITEST			      = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0,  28),
	
	/// @bug     
	MEPROP_DEVCFG1                = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0, 29),
	
	/// @bug     
	MEPROP_DEVCFG2                = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0, 30),
	//  
	MEPROP_BALANCE_TYPE           = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0, 31),
	MEPROP_BALANCE_PORTION_LENGTH = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0, 32),
	MEPROP_BALANCE_UNUSED_POINTS  = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0, 33),
	//    - ./
	MEPROP_BALANCE_ON             = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0, 34),	
	//    - ./
	MEPROP_PROGRAM_BALANCE_ON     = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0, 35),
	//   
	MEPROP_PERIOD_DECAY           = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0, 36),
	// -  
	MEPROP_AVERAGE_POINT_COUNT    = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0, 37),
	//    
	MEPROP_DECAY_CALC_TYPE        = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0, 38),	
	///   
	MEPROP_DATA_CALLBACK         	= MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0, 39),
	///   , l, R	
	MEPROP_HARD_VER					= MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0, 40),
	///  ,l, R/W
	MEPROP_MODE_MANIFOLD			= MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0,  41),
	///    ini     Flash
	MEPROP_FROMINI					= MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0,  42),
	///    ini     Flash 
	MEPROP_ININI					= MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0,  43),
	///  
	MEPROP_METROLOG					= MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0,  44),
	/// ,  
	MEPROP_DATETIME_STR				= MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0,  45),
	/// ,  
	MEPROP_DATETIME					= MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0,  46),
	///   I/O (r/o)
	MEPROP_IO_RESOURCES = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0,  47),
	///  ,   -   8/64  mb-464
	MEPROP_SUBTYPE					= MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0, 48),
	///     1 , R/W
	MEPROP_MODE_MAX_FREQ			= MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0,  49),
	//   1/4  
	MEPROP_QUATER_BRIDGE_ADDITION_INDEX = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0,  50),
	//     
	MEPROP_DAC_POWER_VALUE			= MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0,  51),
	//   
	MEPROP_CALIBR_SHUNT_INDEX		= MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0,  52),
	//     
	MEPROP_ADDITION_CUR_LIST		= MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0,  53),
	//   /
	MEPROP_DETERMINE_BREAK_ON       = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0, 54),
	///  , R
	MEPROP_MANIFOLD_POS= MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0,  55),
	///    , R
	MEPROP_MANIFOLD_POS_RERCENT= MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0,  56),
	///      /, R
	MEPROP_MANIFOLD_FREQ_MOTOR= MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0,  57),
	///     , R
	MEPROP_MANIFOLD_TIMEOUT_MOTOR= MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0,  58),
	///    
	MEPROP_MANIFOLD_COUNTER= MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0,  59),
	///     .    -  MB-152
	MEPROP_NEG_SHIFT_RANGE = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0,  60),
	///  /  
	MEPROP_TERMO_COMP = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0,  61),
	///       
	MEPROP_BURST_SIZE= MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0,  62),
	///   16/24/32 
	MEPROP_DATA_WIDTH = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0,  63),
	///     ,  BLOCK_SIZE       
	///  MS-685      MIC-1170    16 
	MEPROP_BUFFER_SIZE = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0, 64),
	///    (MEPROP_BUFFER_SIZE)  ,    
	MEPROP_BUFFER_PERIOD_MKS = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0, 65),
	

	///     -    MIC-1500
	MEPROP_CALIBR_MODE_ON = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0, 66),
	///     -    MIC-1500
	MEPROP_CONTROL_CHN_ON = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0, 67),
	///   .  -    MIC-1500
	MEPROP_EXTRA_CHN_ON = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0, 68),
	///    -    MIC-1500
	MEPROP_POWER_ON = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0, 69),
	///   , R
	MEPROP_MANIFOLD= MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0,  70),
	///    - /
	MEPROP_POWER_TYPE = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0, 71),
	///      ,  
	///      ,    
	MEPROP_UTS_CHAN_REF           = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0, 72),
	///   ILed
	MEPROP_ILED_IFACE = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0, 73),
	///  
	MEPROP_PERIOD_SAMLPE= MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0, 74),
	///      
	MEPROP_BALANCE_SET_CAL= MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0, 75),

	///   
	MEPROP_UTS_TYPE = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0, 76),
	///   (10   ME-020) - 1 , 0 - 
	MEPROP_SYNC_TYPE = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0, 77),
	///
	MEPROP_ADDRESS_COUNT = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0, 78),

	///     keep-alive
	MEPROP_KEEPALIVE_ENABLED = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0, 79),

	///
	MEPROP_USEVIRTUALCHANS = MAKE_PROPID(mebius_daq::MEPROPCLASSID_BASE, 0, 80),


	MEPROP_COMMUT_ENAGND          = MAKE_PROPID(mebius_daq::MEPROPCLASSID_COMMUTATOR, 0,  1),
	MEPROP_COMMUT_ADCWAIT         = MAKE_PROPID(mebius_daq::MEPROPCLASSID_COMMUTATOR, 0,  2),
	MEPROP_COMMUT_ENAEXTVOLT      = MAKE_PROPID(mebius_daq::MEPROPCLASSID_COMMUTATOR, 0,  3),
	MEPROP_COMMUT_ADC_CNT         = MAKE_PROPID(mebius_daq::MEPROPCLASSID_COMMUTATOR, 0,  4),
	MEPROP_COMMUT_ADCWAIT_TICKS   = MAKE_PROPID(mebius_daq::MEPROPCLASSID_COMMUTATOR, 0,  5),
	MEPROP_COMMUT_ARRAY_PTR       = MAKE_PROPID(mebius_daq::MEPROPCLASSID_COMMUTATOR, 0,  6),
	MEPROP_COMMUT_GNDWAIT         = MAKE_PROPID(mebius_daq::MEPROPCLASSID_COMMUTATOR, 0,  7),

	MEPROPCH_SIGNAL_TYPE          = MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0,  1),
	MEPROPCH_BLOCK_SIZE           = MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0,  2),
	MEPROPCH_DATA_TYPE            = MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0,  3),
	MEPROPCH_START_OFFSET         = MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0,  4),
	MEPROPCH_DEV_TARE             = MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0,  5),
	MEPROPCH_SAMPLE_FREQ          = MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0,  6),
	///   <br>
	///   MebiusDAQ      .
	///     ,   ,   
	MEPROPCH_DEV_TARE_TYPE       = MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0,  7),
	MEPROPCH_CONNECTED           = MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0,  8),
	MEPROPCH_CHANCFG             = MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0,  9),
	MEPROPCH_GNDCFG              = MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0,  10),
	MEPROPCH_DACCFG              = MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0,  11),
	MEPROPCH_COMMUT_PULLUP       = MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0,  12),
	MEPROPCH_START_TYPE          = MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0,  13),
	///       
	MEPROPCH_HAVE_OUT_STREAM     = MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0,  14),
	///   
	MEPROPCH_ORDER_NUM           = MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0, 15),
	///   1 
	MEPROPCH_GAIN_1              = MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0, 16),
	///   2 
	MEPROPCH_GAIN_2              = MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0, 17),
	///  
	MEPROPCH_DELAY               = MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0, 18),
	///    
	MEPROPCH_BALANCE_SOFT        = MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0, 19),
	///   
	MEPROPCH_BALANCE_HARD        = MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0, 21),
	///   () 
	MEPROPCH_MODE_ID             = MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0, 22),
	///   
	/// @bug     
	MEPROPCH_PTR_OFFSET		      = MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0, 23),	
	///    , R
	MEPROPCH_COMMUT_NAMES_LIST   	= MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0,  24),
	///   , R/W
	MEPROPCH_COMMUT              	= MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0,  25),
	///   - , R
	MEPROPCH_GAIN_NAMES_LIST	= MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0,  26),
	///  - , l, R/W
	MEPROPCH_GAIN_INDEX				= MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0,  27),
	///  , R
	MEPROPCH_DEV_TARE_LIST= MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0,  28),
	///
	MEPROP_MIN_MEASURING_FREQ    = MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0,  29),
	///    
	MEPROPCH_BALANCE_PHYS        = MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0, 30),
	/// /  , L, R/W
	MEPROPCH_TEMP_CORRECTION_ENABLED= MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0,  31),
	///   , R
	MEPROPCH_GAUGE= MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0,  32),
	///
	MEPROPCH_EVAL= MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0,  33),
	/// 
	MEPROPCH_CALIBR_KOEF = MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0,  34),
	//    
	MEPROPCH_SHUNT_ON = MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0,  35),
	//  /
	MEPROPCH_TENSOSENSITIVITY = MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0,  36),
	//   
	MEPROPCH_RESISTENCE = MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0,  37),
	//  
	MEPROPCH_CURRENT = MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0,  38),
	//   
	MEPROPCH_SENSOR_TYPE = MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0,  39),
	//   4-   (  )
	MEPROPCH_4WIRE_ON = MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0,  40),
	//   (  )
	MEPROPCH_HFF_STATE = MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0,  41),
	//    ICP
	MEPROPCH_ICP_INDEX = MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0,  42),
	//   (  )
	MEPROPCH_LFF_STATE = MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0,  43),
	//  TEDS
	MEPROPCH_TEDS_STATE = MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0,  44),
	//  
	MEPROPCH_BUS_RATE = MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0,  45),
	//   
	MEPROPCH_LINK_TYPE_START = MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0,  46),
	//     -   MR/MS-451
	MEPROPCH_COMPARATOR_MIN_VALUE = MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0,  47), 
	//     -   MR/MS-451
	MEPROPCH_COMPARATOR_MAX_VALUE = MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0,  48),
	//  -   
	MEPROPCH_CALIBRATION_FACTOR_POWER = MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0,  49), 
	//  -   
	MEPROPCH_CALIBRATION_FACTOR_CURRENT = MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0,  50),
	///    
	MEPROPCH_BALANCE_REF= MAKE_PROPID(mebius_daq::MEPROPCLASSID_CHANNEL, 0, 51)

}MEBASE_PROPIDS;

#endif
