#ifndef __METYPES_H
#define __METYPES_H
///////////////////////////////////////////////////////////////////////////////
//      
///////////////////////////////////////////////////////////////////////////////
// Project: mebius 
//  
// ver 1.0 - 
///////////////////////////////////////////////////////////////////////////////

#include "static_assert.h"


namespace mebase{ 



#define CLASSID_BASE_TASKS 200
#define CLASSID_BASE_USER_TASKS 1000
#define CLASSID_BASE_HOSTS 1200
#define CLASSID_BASE_SYSLINK_TASKS 1400


#ifdef _TMS320C6X
typedef unsigned long long ULONGLONG;
typedef unsigned int  ULONG;
typedef signed int  LONG;
typedef unsigned short USHORT;
typedef signed short  SHORT;
typedef unsigned char  BYTE;
#define MEBCALLTYPE 
#else 
#ifdef _MSC_VER
typedef unsigned __int64  ULONGLONG;
typedef __int64  LONGLONG;
typedef unsigned __int32  ULONG;
typedef unsigned __int16  USHORT;
typedef __int32  LONG;
typedef __int16  SHORT;
typedef unsigned __int8   BYTE;
#define MEBCALLTYPE __stdcall
#else
#ifdef __BORLANDC__
typedef unsigned long long ULONGLONG;
typedef unsigned int  ULONG;
typedef signed int  LONG;
typedef unsigned short USHORT;
typedef signed short  SHORT;
typedef unsigned char  BYTE;
#define MEBCALLTYPE __stdcall
#else
#ifdef __clang__
typedef unsigned long long ULONGLONG;
typedef unsigned int  ULONG;
typedef signed int  LONG;
typedef unsigned short USHORT;
typedef signed short  SHORT;
typedef unsigned char  BYTE;
#define MEBCALLTYPE __stdcall
#else
#error "Undefined compiler"
#endif
#endif
#endif
#endif


typedef ULONG BUSID;
typedef ULONG DEVICEID;
typedef ULONG DEVICECLASSID;
typedef ULONG DEVICESTATE;
typedef ULONG CHANSTATE;

typedef BYTE* PBYTE;



///  -     
typedef LONG MEBRESULT;

///   
typedef ULONG CLASSID;

///  ,       
///  32 
///  2 ,  
/// 10 , CLASSID
///  6 ,   
/// 14 , 

typedef ULONG TASKID;

STATIC_ASSERT(sizeof (TASKID)==4);

STATIC_ASSERT(sizeof (bool)==1);
STATIC_ASSERT(sizeof (double)==8);
STATIC_ASSERT(sizeof (float)==4);

typedef const char* LPCSTR;
typedef char* LPSTR;

typedef void* HANDLE;


#define MAKE_TASKID(core, classid, index, spec) \
    ((TASKID) (\
			((mebase::ULONG)(core) << 30) | \
			((mebase::ULONG)(classid) << 20) | \
			((mebase::ULONG)(index) << 14) | \
			((mebase::ULONG)(spec)) \
		))
}

#define TASKID_GET_CLASS(taskid) \
		(mebase::ULONG)((0x03FF00000&(taskid))>>20)


#define TASKID_GET_CORE(taskid) \
		(mebase::ULONG)((0xC0000000&(taskid))>>30)

#endif
