
#ifndef IPROCESSINGMANAGER_H
#define IPROCESSINGMANAGER_H

#include "IProcessing.h"

namespace medyan {

extern const GUID IID_IProcessingManager;


struct PROCESSING_FACTORY_INFO
{
	long cb;
	BSTR name;
	BSTR descr;
	IPicture* icon;
};

/// @interface IProcessingManager
///       
/// 
class IProcessingManager : public IUnknown
{
public:
	// 
	///   
	virtual HRESULT STDMETHODCALLTYPE RegisterFactory(GUID idFactory, IProcessingFactory* pFactory) = 0;
	///     
	virtual HRESULT STDMETHODCALLTYPE UnregisterFactory(GUID idFactory) = 0;

	//  
	///  
	virtual HRESULT STDMETHODCALLTYPE CreateProcessing(GUID idFactory, IProcessing** pProcessing, PROCESSINGID* a_pnId = 0) = 0;
	virtual HRESULT STDMETHODCALLTYPE GetProcessing(PROCESSINGID idProcessing, IProcessing** pProcessing) = 0;


	virtual HRESULT STDMETHODCALLTYPE GetCount(int* nCount)const = 0;
	virtual HRESULT STDMETHODCALLTYPE GetFactory(int nIndex, const IProcessingFactory** pidFactory)const = 0;

	//     
	
	///   
	virtual HRESULT STDMETHODCALLTYPE RegisterPage(GUID idFactory, LONG idPage, IClassFactory* pFactory) = 0;

	///     
	/// @param idPage   -1      
	///            
	virtual HRESULT STDMETHODCALLTYPE UnregisterPage(GUID idFactory, LONG idPage) = 0;

	///      
	virtual HRESULT STDMETHODCALLTYPE GetPagesCount(GUID idFactory, LONG* pnCount) const = 0;

	///   
	virtual HRESULT STDMETHODCALLTYPE CreatePage(GUID idFactory, LONG idPage, IPropertyPage** pPPage) = 0;



/*
	virtual HRESULT STDMETHODCALLTYPE GetProcessingInfo(GUID idFactory, PROCESSING_FACTORY_INFO* pInfo) = 0;
	virtual HRESULT STDMETHODCALLTYPE GetProcessingId(int nIndex, GUID* pidFactory) = 0;
	virtual HRESULT STDMETHODCALLTYPE GetProcessingCount(int* nCount) = 0;
*/
};
}

#endif
