//  WinPOS
//  Signals
//    TISignal      WinPOS
//  ------------------------------------
//      TISignal        - 
//      TSignal         - 
//      TIntervalSignal - 
//  ------------------------------------
//  (c)  "" 1999,2000 .

//    : ISignal.h         
//  : MVC++6.0
//  : OK

//---------------------------------------------------------------------------
#ifndef ISignalH
#define ISignalH
//---------------------------------------------------------------------------

/*
#ifndef STDMETHODCALLTYPE
#define STDMETHODCALLTYPE
#endif
*/

//#include <atlbase.h>
#include <Unknwn.h>

namespace Signals
{

class ISignal : public IUnknown
{
public:
	enum S_CHARACT { 
		SC_NORMAL = 0, 
		SC_SPECTR, 
		SC_LOGSPEC 
	};
	//   (TT=Tannsformer Type)
	enum S_TTYPE { 
		TT_NULL, 
		TT_TRANSF, 
		TT_MULTI, 
		TT_KOEF, 
		TT_XYNODE 
	};
	//  (D=Details)     = TT_TRANSF
	enum S_TTYPED { TTD_LINE=0x10, TTD_TRANSF1=0x20, TTD_TRANSF2=0x30, TTD_TRANSFN=0x40, TTD_TRANSFINT=0x50 };

	ISignal() { };
	virtual ~ISignal() { };

	virtual double STDMETHODCALLTYPE GetX(int index) = 0;
	virtual double STDMETHODCALLTYPE GetY(int index, bool viaTransformer = true) = 0;
	virtual double STDMETHODCALLTYPE GetYX(double x, int pow = 1) = 0;
	virtual void STDMETHODCALLTYPE SetX(int index, double x) = 0;
	virtual void STDMETHODCALLTYPE SetY(int index, double y, bool viaTransformer = true) = 0;

	virtual int STDMETHODCALLTYPE GetSize() = 0;
	virtual void STDMETHODCALLTYPE Resize(int size) = 0;
	virtual int STDMETHODCALLTYPE GetTransformerType() = 0;
	
	// ...
	virtual void* STDMETHODCALLTYPE GetTransformer() = 0;
	// ...
	virtual void STDMETHODCALLTYPE SetTransformer(void* newtr = NULL) = 0;

	//    : VT_I2, VT_R4, VT_R8  ..
	virtual int STDMETHODCALLTYPE GetDataType() = 0;

	//  ( ),      X
	virtual double STDMETHODCALLTYPE GetDeltaX(void) = 0;
	//   ( ),      X
	virtual void   STDMETHODCALLTYPE SetDeltaX(double deltaX) = 0;

	//    ( ),      X
	virtual double STDMETHODCALLTYPE GetStartX(void) = 0; 
	//    ( ),      X
	virtual void   STDMETHODCALLTYPE SetStartX(double startX) = 0;
	//    (),    (:)
	virtual void STDMETHODCALLTYPE GetStartTime( LPSYSTEMTIME lpStartTime ) = 0; 

  //      ,   
  virtual DWORD STDMETHODCALLTYPE GetTimeCounter(void) = 0; 

	//    ,     X 
	// (.  GetStartX, GetDeltaX)
	virtual void STDMETHODCALLTYPE GetRangeX(double* minX, double* maxX) = 0;
	//  .  .  
	virtual int STDMETHODCALLTYPE GetMinMax(double* min, double* max, void (*pNotify)(int) = 0) = 0;
	virtual int STDMETHODCALLTYPE SearchMinMax(void (*pNotify)(int) = 0) = 0;

  virtual bool STDMETHODCALLTYPE IsMinMaxCalculated() { double min, max; GetMinMax(&min, &max); return (max>=min); }

	//    
	virtual void STDMETHODCALLTYPE GetK1K0(double* k1, double* k0) = 0;
	//    
	virtual void STDMETHODCALLTYPE SetK1K0(double k1 = 1, double k0 = 0) = 0;

	// *** SignalInfo ***

	virtual const char* STDMETHODCALLTYPE GetSName(/*BOOL bFull = FALSE*/) = 0;
	virtual void STDMETHODCALLTYPE SetSName(const char* newSName) = 0;

	virtual const char* STDMETHODCALLTYPE GetNameX() = 0;
	virtual void STDMETHODCALLTYPE SetNameX(const char* newNameX) = 0;

	virtual const char* STDMETHODCALLTYPE GetNameY() = 0;
	virtual void STDMETHODCALLTYPE SetNameY(const char* newNameY) = 0;

	virtual const char* STDMETHODCALLTYPE GetComment() = 0;
	virtual void STDMETHODCALLTYPE SetComment(const char* newComment) = 0;

	virtual unsigned __int16 STDMETHODCALLTYPE GetCharacteristic() = 0;
	virtual void STDMETHODCALLTYPE SetCharacteristic(const unsigned __int16 newCharacteristic) = 0;

	//        .
	//    y=y(i)       
	//  .
	virtual int STDMETHODCALLTYPE IndexOf(double x) = 0;

	//  /
	virtual int STDMETHODCALLTYPE lockdata() = 0;
	virtual int STDMETHODCALLTYPE unlockdata() = 0;
	virtual int STDMETHODCALLTYPE lockcount() = 0;
};

};

#endif
