//! @copyright ()  , 1996 - 2012. All rights reserved.
//! <http://www.nppmera.ru>
//!
//! @file blaccess.h
//!
//! @date 2001-2012
//!
//! @author  ..
//! @brief  Recorder.       
//! @details 
//!
//! @version 3.0

#ifndef BLACCESS_H
#define BLACCESS_H

// {C2535841-49B1-11d7-9244-00E029288A7F}
static const GUID IID_IBlockAccess =
{ 0xc2535841, 0x49b1, 0x11d7, { 0x92, 0x44, 0x0, 0xe0, 0x29, 0x28, 0x8a, 0x7f } };

// {D82A2A41-49B1-11d7-9244-00E029288A7F}
static const GUID CLSID_BlockAccess = 
{ 0xd82a2a41, 0x49b1, 0x11d7, { 0x92, 0x44, 0x0, 0xe0, 0x29, 0x28, 0x8a, 0x7f } };




#include "rctypes.h"
/// @interface IBlockAccess
///     .
///     (@ref ITag).   
///   IUnknown::QueryInterface  id IID_IBlockAccess
class IBlockAccess: public IUnknown
{
public:

	///    .
	///       .
	///          .
	virtual ULONG   STDMETHODCALLTYPE GetReadyBlocksCount() = 0;

	///     
	virtual ULONG   STDMETHODCALLTYPE GetBlocksCount() = 0;

	///   
	virtual ULONG   STDMETHODCALLTYPE GetBlocksSize() = 0;

	///   
	virtual ULONG   STDMETHODCALLTYPE GetVectorSize() = 0;

	///   
	virtual ULONG   STDMETHODCALLTYPE GetVectorCapacity() = 0;

	///  
	///      .  
	///    @ref UnlockVector
	virtual ULONG   STDMETHODCALLTYPE LockVector() = 0;

	///  
	virtual ULONG   STDMETHODCALLTYPE UnlockVector() = 0;

	///   
	virtual ULONG   STDMETHODCALLTYPE GetLockCount()=0;


	///     floa'
	virtual HRESULT STDMETHODCALLTYPE GetVectorR4(
				float*  pBlock, 
				long int nFirstBlockIndex, 
				long int nSize, 
				BOOL a_fViaTranformer
			) = 0;
			
	///     int'
	virtual HRESULT STDMETHODCALLTYPE GetVectorI2(
				short*  pBlock, 
				long int nFirstBlockIndex, 
				long int nSize, 
				BOOL a_fViaTranformer
			) = 0;
			
	///     unsigned int'
	virtual HRESULT STDMETHODCALLTYPE GetVectorU2(
				unsigned short* pBlock, 
				long int nFirstBlockIndex, 
				long int nSize, 
				BOOL a_fViaTranformer
			) = 0;
			
	///     double'
	virtual HRESULT STDMETHODCALLTYPE GetVectorR8(
				double* pBlock, 
				long int nFirstBlockIndex, 
				long int nSize, 
				BOOL a_fViaTranformer
			) = 0;


	///     XY
	virtual BOOL    STDMETHODCALLTYPE isContainTimes() = 0;

	///    
	virtual BOOL    STDMETHODCALLTYPE isUTSVector() = 0;

	///       
	virtual HRESULT STDMETHODCALLTYPE GetVectorUTS(
				UTSPAIR* pBlock, 
				long int nFirstBlockIndex, 
				long int nSize, 
				BOOL fReserved 
			) = 0;

	///      (, )
	virtual HRESULT STDMETHODCALLTYPE GetVectorPairR8(
				R8PAIR* pBlock, 
				long int nFirstBlockIndex, 
				long int nSize, 
				BOOL fViaTranformer
			) = 0;

	///      (, )
	virtual HRESULT STDMETHODCALLTYPE GetVectorPairI2(
				I2PAIR* pBlock, 
				long int nFirstBlockIndex, 
				long int nSize, 
				BOOL fViaTranformer
			) = 0;

     ///   
     virtual HRESULT STDMETHODCALLTYPE GetVectorTimes(
				double* pBlock, 
				long int nFirstBlockIndex, 
				long int nSize, 
				BOOL a_fUTSEnabled
			) = 0;


     ///       
     virtual double STDMETHODCALLTYPE GetBlockUTSTime(long int nBlockIndex) = 0;

     ///        
     virtual double STDMETHODCALLTYPE GetBlockDeviceTime(long int a_nBlockIndex) = 0;

     ///    
     /// @todo      
     virtual ULONG  STDMETHODCALLTYPE GetBlockState(long int nBlockIndex) = 0;
    
 
};
#endif 
