#ifndef ITAGGRP_H
#define ITAGGRP_H

#include "itag.h"

// {76B0B801-4FCA-11d7-9244-00E029288A7F}
static const GUID IID_ITagsGroup = 
{ 0x76b0b801, 0x4fca, 0x11d7, { 0x92, 0x44, 0x0, 0xe0, 0x29, 0x28, 0x8a, 0x7f } };

// {76B0B802-4FCA-11d7-9244-00E029288A7F}
static const GUID CLSID_TagsGroup = 
{ 0x76b0b802, 0x4fca, 0x11d7, { 0x92, 0x44, 0x0, 0xe0, 0x29, 0x28, 0x8a, 0x7f } };

//     /   ITagsGroup::GetProperty/ITagsGroup::SetProperty
enum {
	TGRPROP_WRITETOPERSONALFRAME,   //            [in,out]
	TGRPROP_PERSONALFRAMENAME,      //              [in,out]
	TGRPROP_ENABLEREC,              //      [in,out]
	TGRPROP_DESCRIBE,               //                    [in,out]
	TGRPROP_EXPANDEDVIEW            ///              [in,out]

};

// 
enum{
  TGRNTF_PREPAREFRAME,            //     dwParam=(LPCSTR)DataFolder
  TGRNTF_CREATEINFOFILE           //    .mera dwParam=(LPCSTR)DataFolder
};

class ITag;
class ITagsGroup: public IUnknown
{
  public:
    
    //   
    virtual HRESULT STDMETHODCALLTYPE GetName(CHAR* a_pchName)  = 0;
    //   
    virtual HRESULT STDMETHODCALLTYPE SetName(CHAR* a_pchName)  = 0;
    
    //   
    virtual HRESULT STDMETHODCALLTYPE AddTag(ITag* a_pTag)  = 0;
    
    //   
    virtual HRESULT STDMETHODCALLTYPE RemoveTag(ITag* a_pTag)  = 0;


    

    //  
    virtual ULONG   STDMETHODCALLTYPE GetTagsCount()  = 0;
    //   
    virtual HRESULT STDMETHODCALLTYPE GetTagByIndex(ITag** a_pTag, ULONG a_nIndex)  = 0;
    //   
    virtual HRESULT STDMETHODCALLTYPE GetTagByName(ITag** a_pTag, CHAR* a_pchName)  = 0;
    
    //   
    virtual HRESULT STDMETHODCALLTYPE StartRec()  = 0;
    //   
    virtual HRESULT STDMETHODCALLTYPE StopRec()  = 0;

    //   
    virtual BOOL    STDMETHODCALLTYPE GetRecEnabled()  = 0;
    
    //   
    virtual void    STDMETHODCALLTYPE SetRecEnabled(BOOL a_bValue)  = 0;



    //   
    virtual HRESULT STDMETHODCALLTYPE Notify(DWORD a_dwCommand, DWORD a_dwParam)  = 0;
    //   
    virtual HRESULT STDMETHODCALLTYPE SetProperty(DWORD a_dwPropertyID, VARIANT a_Value)  = 0;
    //   
    virtual HRESULT STDMETHODCALLTYPE GetProperty(DWORD a_dwPropertyID, VARIANT& a_Value)  = 0;
};
#endif