#ifndef IUISRV_H
#define IUISRV_H

enum{
	UISH_SHOW,
	UISH_HIDE
};

enum{
	UISN_ENABLESETUP,
	UISN_UPDATETITLE,
	UISN_UPDATESTATUSBAR,
	UISN_UPDATECURRTAGINFO,
	UISN_ENABLE,
	UISN_RCSAVECONFIG,
	UISN_RCLOADCONFIG,
	UISN_ENTERRCCONFIG,
	UISN_LEAVERCCONFIG,
	UISN_BROADCAST,
	UISN_UPDATE_DATA,
	UISN_RCSTART,
	UISN_RCSTOP,
	UISN_RCPLAY,
	UISN_UPDATE_FORMS,
	UISN_BEFORE_RCSTART,
	UISN_BEFORE_RCSTOP,

	UISN_INTERNAL = 0x8000,
	UISN_REFLECT_PRETRANSLATE,
	UISN_RESET_CONFIG,
	UISN_ON_LINK_TO_RC_CORE

};

enum{
	UISP_RECORDERLINK,
	UISP_TAGS_FILTER
};

//     
//   OpenSettingsDialog
enum{
	OSDC_MAIN,
	OSDC_TAG,
	OSDC_VFORMS
};

#include "rcplugin.h"



// {12920205-4119-4a7f-8709-136594FD9528}
static const GUID IID_IUIServer = 
{ 0x12920205, 0x4119, 0x4a7f, { 0x87, 0x9, 0x13, 0x65, 0x94, 0xfd, 0x95, 0x28 } };

// {EAD4F9B6-C015-4d28-9579-481D784BC1DA}
static const GUID CLSID_IUIServer = 
{ 0xead4f9b6, 0xc015, 0x4d28, { 0x95, 0x79, 0x48, 0x1d, 0x78, 0x4b, 0xc1, 0xda } };


class ITag;


class IUIServer : public IUnknown
{
	public:
		virtual HRESULT STDMETHODCALLTYPE Init(ULONG a_ulParam)=0;
		virtual HRESULT STDMETHODCALLTYPE Close()=0;
		virtual HRESULT STDMETHODCALLTYPE Show(ULONG a_ulFlags)=0;
		virtual HRESULT STDMETHODCALLTYPE Notify(ULONG a_ulCommand, ULONG a_ulParam, int a_nIndex=-1)=0;
		virtual ULONG   STDMETHODCALLTYPE GetWindowDescriptor()=0;


		//   UI 
		virtual HRESULT STDMETHODCALLTYPE SetProperty(DWORD a_dwPropertyID, VARIANT a_Value, LONG a_lSubPropertyIndex, DWORD a_dwReserved=NULL)=0;

		//   UI 
		virtual HRESULT STDMETHODCALLTYPE GetProperty(DWORD a_dwPropertyID, VARIANT& a_Value, LONG a_lSubPropertyIndex=0, DWORD a_dwReserved=NULL)=0;

		virtual ULONG   STDMETHODCALLTYPE GetSelectedTagsCount()=0;
		virtual ITag*   STDMETHODCALLTYPE GetSelectedTag(int a_nIndex)=0;
  
		//    
		//  a_unDialogCode -   OSDC_XXX
		//  a_unPageIndex -   
		//  a_unFlags -   reserved, must be 0 
		//  a_pvboolRetCode -      
		//   
		virtual HRESULT STDMETHODCALLTYPE OpenSettingsDialog(
				ULONG unDialogCode, 
				ULONG unPageIndex, ULONG unFlags, 
				VARIANT_BOOL* pvboolRetCode
			) = 0;


		//    PN_ON_SWITCH_TO_UI_THREAD    
		// since v2.7.0.17
		virtual HRESULT STDMETHODCALLTYPE PostSwitchThreadNotification(IRecorderPlugin* pPlugin)=0;


		//       
		// since v2.7.3
		virtual ULONG		STDMETHODCALLTYPE GetSelectedTagIndex(int nIndex)=0;


};
#endif