{---------------------------------------------------------------------}
{  ()  plug-in`    Recorder }
{              }
{ : Borland Delphi 6.0                                      }
{  " " 2004.                                               }
{---------------------------------------------------------------------}

unit tags;
interface
uses Windows, signal;
type
   //    
   LINKSTATE = (
      LS_HARDWARE, //   
      LS_VIRTUAL,  //        
      LS_LOST      //    ,   
   );   
const
//   ITag::Notify
   TN_UPDATETAGTX =         0; //  
   TN_ERASETAGTX =          1; //    
   TN_SETVECTORDELTA =      2; //  dX   ,   VirtualTags
   TN_WRITETAGTXINFOFILE =  3; //    ()
   TN_PREPARETARGETS =      4; //   dwParams==MASK ()
   TN_FINISHTARGETS =       5; //    dwParams==MASK ()
   TN_STARTREC =            6; //      ()
   TN_STOPREC =             7; //     ()
   TN_ERASEDEVTX =          8; //     

//     /   ITag::GetProperty/ITag::SetProperty
   TAGPROP_BUFFSIZE =        0; //   FIFO                            [out]
   TAGPROP_ESTIMATOR =       1; //                              [in, out]
   TAGPROP_ESTIMATE =        2; //                                        [out]
   TAGPROP_DATATYPE =        3; //                                     [in, out]
   TAGPROP_HARDWAREADRESS =  4; //                         [out]
   TAGPROP_TYPE =            5; //                               [in, out]
   TAGPROP_DEVCHANID =       6; //                [out]
   TAGPROP_MINVALUE =        7; //                           [in, out]
   TAGPROP_MAXVALUE =        8; //                          [in, out]
   TAGPROP_TARE =            9; //                    [in, out]
   TAGPROP_OWNER =          10; //  ( IRecorderPlugin)         [out]
   TAGPROP_MODULE =         11; //  (HardLink)                            [out]
   TAGPROP_DEVSIGNALTYPE =  12; //     , ..         [in, out]
   TAGPROP_UNITS =          13; //                              [in, out]
   TAGPROP_RECENABLED =     14; //                 [out]
   TAGPROP_DESCRIBE =       15; //                                      [in, out]
   TAGPROP_MODULENAME =     16; //                                     [out]
   TAGPROP_MODULESERNUM =   17; //                           [out]
   TAGPROP_DEVTARE =        18; // .        [in, out]
   TAGPROP_MINUSERVALUE =   19; //          [in, out]
   TAGPROP_MAXUSERVALUE =   20; //         [in, out]
   TAGPROP_AUTORANGE =      21; //                                              [in, out]
   TAGPROP_IRECORDER =      22; //   IRecorder        [out]
   TAGPROP_LEVELEXCEED =    23; //                              [in, out]
   TAGPROP_VIEWRANGE =      24; //                           [in]
   TAGPROP_MAXXVIEWRANGE =  25; //      X   [in, out]
   TAGPROP_MODCHANNUMBER =  26; //                            [out]

   //  
   TTAG_VECTOR = $0001;         //  
   TTAG_SCALAR = $0002;         //  
   TTAG_OUTPUT = $0100;         //  

   //  
   ESTIMATOR_EMPTY = $0000000;
   ESTIMATOR_MEAN  = $0000001;   // MO
   ESTIMATOR_RMSV  = $0000002;   // 
   ESTIMATOR_RMSD  = $0000004;   // 
   ESTIMATOR_PEAK  = $0000008;   // 
   ESTIMATOR_P2P   = $0000010;   // -
   ESTIMATOR_LAST  = ESTIMATOR_P2P;
   
const
   //     /  
   // ITagsGroup::GetProperty/ITagsGroup::SetProperty
   TGRPROP_WRITETOPERSONALFRAME = 0; //            [in,out]
   TGRPROP_PERSONALFRAMENAME =    1; //              [in,out]
   TGRPROP_ENABLEREC =            2; //      [in,out]
   TGRPROP_DESCRIBE =             3; //                    [in,out]

   // 
   TGRNTF_PREPAREFRAME =   0; //     dwParam=(LPCSTR)DataFolder
   TGRNTF_CREATEINFOFILE = 1; //    .mera dwParam=(LPCSTR)DataFolder

type
   //  
   ITagsGroup = interface;

   //   
   ITag = interface
   ['{E8DAE361-53EE-11d7-9244-00E029288A7F}']
      //     
      function GetLinkState: LINKSTATE; stdcall;
      //    
      function Edit: boolean; stdcall;
      //  
      function SetName(const pchName: LPCSTR): boolean; stdcall;
      //  
      function GetName: LPCSTR; stdcall;

      //   
      procedure SetFreq(const dblFreq: double); stdcall;
      //   
      function GetFreq: double; stdcall;

      //   
      function Notify(const dwCommand: DWORD; const dwParam: DWORD): boolean; stdcall;

      //   
      function SetProperty(const dwPropertyID: DWORD;
                           {const} Value: OleVariant): boolean; stdcall;
      //   
      function GetProperty(const dwPropertyID: DWORD;
                           var Value: OleVariant): boolean; stdcall;

      //    
      function GetData: pointer{ISignal}; stdcall;
      function SynchroReadDataBlock(const dblFreq: double; const dwPortionLen: DWORD;
                                    var dblBuffer; {   DOUBLE}
                                    const Tare: boolean): HRESULT; stdcall;

      //    (      )
      function isCfgWritable: boolean; stdcall;
      //    (      )
      function CfgWritable(const fNewState: boolean): boolean; stdcall;
      //     ( )
      function PushData(var pData; const nCount: integer): boolean; stdcall;
      //      ( )
      function PushValue(const dValue: double; const dXValue: double): boolean; stdcall;

      //       
      function SetYRange(const a_fltRange: single): boolean; stdcall;
      //       
      function GetYRange: single; stdcall;

      //       0.1%
      function SetYShift(const fltShift: single): boolean; stdcall;

      //       0.1%
      function GetYShift: single; stdcall;

      //   
      function LinkGroup(const Group: ITagsGroup): HRESULT; stdcall;
      //    
      function GetGroup(var ppGroup: ITagsGroup): HRESULT; stdcall;

      //   ,     Variant
      function GetDataType: TVarType; stdcall;

      // 
      procedure SetEstimate(const dblValue: double; const nMask: ULONG); stdcall;
      // 
      function GetEstimate(const nEstimator: ULONG): double; stdcall;
      //   
      function SetEstimatorsMask(const nMask: ULONG): HRESULT; stdcall;
      //   
      function GetEstimatorsMask: ULONG; stdcall;

      //    
      function Eval(const a_dblValue: double): double; stdcall;

      //v1.06.2+
      //       
      function SetXRange(const a_fltRange: single): boolean; stdcall;
      //       
      function GetXRange: single; stdcall;

      //       
      function SetXShift(const fltShift: single): boolean; stdcall;
      //       
      function GetXShift: single; stdcall;
   end;

   //  
   ITagsGroup = interface
   ['{76B0B801-4FCA-11d7-9244-00E029288A7F}']
      //   
      {      ,    
      STDSTRSIZE,   256 ,      }
      function GetName(const pchName: LPCSTR): HRESULT; stdcall;
      //   
      function SetName(const pchName: LPCSTR): HRESULT; stdcall;

      //   
      function AddTag(pTag: ITag): HRESULT; stdcall;

      //   ,         
      function RemoveTag(pTag: ITag): HRESULT; stdcall;

      //  
      function GetTagsCount: ULONG; stdcall;
      //   
      function GetTagByIndex(var pTag: ITag; const nIndex: ULONG): HRESULT; stdcall;
      //   
      function GetTagByName(var pTag: ITag; const pchName: LPCSTR): HRESULT; stdcall;

      //   
      function StartRec: HRESULT; stdcall;
      //   
      function StopRec: HRESULT; stdcall;

      //   
      function GetRecEnabled: boolean; stdcall;

      //   
      procedure SetRecEnabled(const bValue: boolean); stdcall;    

      //   
      function Notify(const dwCommand: DWORD; const dwParam: DWORD): HRESULT; stdcall;
      //   
      function SetProperty(const dwPropertyID: DWORD;
                           {const} Value: OleVariant): HRESULT; stdcall;
      //   
      function GetProperty(const dwPropertyID: DWORD;
                           var Value: OleVariant): HRESULT; stdcall;
   end;
implementation
end.


